      SUBROUTINE ITG_AB(FR,p,a,b,eps,integ,ierr)

! #####################################################
! #
! # Integrator from a to b of f(x)
! #
! # Input parameters:
! # FR - symbolic name of the integrand function
! # p  - array of parameters needed by FR
! # a  - lower integration limit
! # b  - upper integration limit
! # eps - absolute error tolerance 
! #
! # Output arguments:
! # integ - value of the integral
! # ierr - error flag
! #
! # 04/04/02, Juan Pedro Mellado, UCSD
! #
! #####################################################

      IMPLICIT NONE

#include "types.h"

      TREAL FR,p(*)
      EXTERNAL FR
      TREAL a, b, eps, integ
      TINTEGER ierr

      TREAL x1,x2,x3,f1,f2,f3
      TINTEGER ir, evals

      ierr=0
      IF ( a .GE. b ) ierr = 1
      IF ( ierr.NE.0 ) GO TO 999

      x1 = a
      x2 = (a+b)*C_05_R
      x3 = b
      f1 = FR(x1,p)
      f2 = FR(x2,p)
      f3 = FR(x3,p)
      evals = 0
      CALL RECURSIMP(FR,p,x1,x2,x3,f1,f2,f3,eps,integ,evals,ir)
      IF (ir.NE.0) ierr=2
      IF (ierr.NE.0) GO TO 999

 999  RETURN
      END

