      SUBROUTINE SGS_ARM_RANS_ZSG(imax, jmax, kmax, kmax_total,&
           area, rtime, delta_w, scaley, x, y, z, dx, dy, dz, &
           rho, z1, rhoz2_sg, wrk1d, wrk3d)

      IMPLICIT NONE

#include "types.h"
#include "integers.h"

      TINTEGER imax, jmax, kmax, kmax_total
      TREAL area, rtime, delta_w, scaley

      TREAL x(imax)
      TREAL y(jmax)
      TREAL z(kmax_total)
      TREAL dx(imax)
      TREAL dy(jmax)
      TREAL dz(kmax_total)

      TREAL rho(imax,jmax,kmax)
      TREAL z1(imax,jmax,kmax)

      TREAL wrk1d(jmax,*) 
      TREAL wrk3d(imax,jmax,kmax)
 
      TREAL rhoz2_sg(jmax)

      TINTEGER k, i, j, ij, iprofile
      TREAL EZ_dns, EZ_les
      TREAL SIMPSON_NU, AVG_IK

      TREAL x_shape(128), y_shape(128)
      TREAL x_shape_min, x_shape_max, eta, y_center
      TINTEGER nmax, ileft

      iprofile = 1

#ifdef SINGLE_PREC
      EZ_dns = C_1EM2_R*( rtime*0.050947e0 - 0.6959e0 )
#else
      EZ_dns = C_1EM2_R*( rtime*0.050947d0 - 0.6959d0 )
#endif
!#ifdef SINGLE_PREC
!  EZ_dns = C_1EM2_R*( rtime*0.1537e0 - 1.9067e0 )
!#else
!  EZ_dns = C_1EM2_R*( rtime*0.1537d0 - 1.9067d0 )
!#endif

#define rR(j)           wrk1d(j,1)
#define fZ(j)           wrk1d(j,2)
#define WRK1D_LOC(j)    wrk1d(j,3)

      DO j = 1,jmax

         DO k = 1,kmax
            DO i = 1,imax
               wrk3d(i,1,k) = rho(i,j,k)*z1(i,j,k)
               wrk3d(i,2,k) = wrk3d(i,1,k)*z1(i,j,k)
            ENDDO
         ENDDO

         rR(j) = AVG_IK(imax, jmax, kmax, j, &
              rho, dx, dz, area)
         fZ(j) = AVG_IK(imax, jmax, kmax, i1, &
              wrk3d, dx, dz, area)/rR(j)
         rhoz2_sg(j) = &
              AVG_IK(imax, jmax, kmax, i2, wrk3d, dx, dz, area) -&
              rR(j)*fZ(j)*fZ(j)

      ENDDO

      IF ( iprofile .EQ. i1 ) THEN
!     DO j = 1,jmax
!        rhoz2_sg(j) = rhoz2_sg(j)/rR(j)
!     ENDDO
         EZ_les =  SIMPSON_NU(jmax,rhoz2_sg(1),y)
         DO j = 1,jmax
!        rhoz2_sg(j) = rR(j)*rhoz2_sg(j)*
            rhoz2_sg(j) = rhoz2_sg(j)*(EZ_dns/EZ_les-C_1_R)
         ENDDO
      ELSE
         OPEN(i23,file='Z2rms_shape')
         READ(i23,*) nmax
         DO ij = 1,nmax
            READ(i23,*) x_shape(ij), y_shape(ij)
         ENDDO
         CLOSE(i23)
         x_shape_min = x_shape(1)
         x_shape_max = x_shape(nmax)
         y_center = y(1)+C_05_R*scaley
         DO j = 1,jmax
            eta = (y(j)-y_center)/delta_w
            IF ( eta .LE. x_shape_min .OR.&
                 eta .GE. x_shape_max ) THEN
               WRK1D_LOC(j) = C_0_R
            ELSE
               ileft = INT((eta-x_shape_min)/&
                    ((x_shape_max-x_shape_min)/(nmax-1)))
               WRK1D_LOC(j) = y_shape(ileft)+&
                    (y_shape(ileft+1)-y_shape(ileft))/&
                    (x_shape(ileft+1)-x_shape(ileft))*&
                    (eta-x_shape(ileft))
            ENDIF
         ENDDO
         DO j = 1,jmax
            rhoz2_sg(j) = rR(j)*EZ_dns/delta_w*WRK1D_LOC(j) -&
                 rhoz2_sg(j)
         ENDDO
      ENDIF
      
#ifdef _DEBUG
      DO j = 1,jmax
         WRK1D_LOC(j) = rhoz2_sg(j)/rR(j)
      ENDDO
      CALL IO_WRITE_ASCII_FIELD('Z2SG_rans.dat', i1, jmax, i1, &
           WRK1D_LOC(1))
#endif

#undef WRK1D_LOC
#undef rR
#undef fZ

      RETURN
      END
