      SUBROUTINE SGS_ARM_SPTL_C0(ipr, itime, ng, nre, visc, imax, jmax, &
           delta, kin, zvar, diss, wrk, c0, messageles)

! Calculation of model coefficient using spectral table

      IMPLICIT NONE

#include "types.h"
#include "nfile.h"
#include "dns_error.h"
#include "integers.h"

      TINTEGER ipr, itime
      TINTEGER ng, nre
      TINTEGER imax, jmax
      TREAL visc(imax,jmax), delta(imax,jmax)
      TREAL kin(imax,jmax), zvar(imax,jmax), diss(imax,jmax)
      TREAL wrk(*)
      TREAL c0(imax,jmax)
      CHARACTER*(*) messageles

      TREAL ret, gamma, log_ret, log_gamma, length
      TREAL SGS_ARM_SPL2, dum
      TREAL remin, remax, gmin, gmax, c0min, c0max, c0mean
      TINTEGER i, j, ire, ic, ihit, l1, l2
      CHARACTER*98 line

! Statistics
      ihit = 0

      remax = C_0_R
      remin = C_BIG_R
      
      gmax = C_0_R
      gmin = C_BIG_R
      
      c0max = C_0_R
      c0min = C_BIG_R
      c0mean = C_0_R

      ire = 1+ng*nre
      ic = ire+nre

! Flow Parameters
      DO i = 1,imax
         length = zvar(i,jmax/2)*SQRT(kin(i,jmax/2))/diss(i,jmax/2)
         DO j = 1,jmax

            ret = kin(i,j)*zvar(i,j)/(visc(i,j)*diss(i,j))
            
!        IF ( ret .GT. C_10_R ) THEN
            IF ( ret .GT. EXP(wrk(ire)) ) THEN

!           gamma = C_05_R*delta(i,j)/length
               gamma = C_05_R*delta(i,j)/zvar(i,j)/SQRT(kin(i,j))&
                    *diss(i,j)
               
               ihit = ihit + 1
               
               gmax = MAX(gamma,gmax)
               gmin = MIN(gamma,gmin)              
               remax = MAX(remax, ret)
               remin = MIN(remin, ret)
               
! Limit values to table limits (gamma later)
               log_gamma = LOG(gamma)
               
               log_ret = LOG(ret)
               log_ret = MIN(log_ret, wrk(ire+nre-1))
               log_ret = MAX(log_ret, wrk(ire))
               
! Interpolate Table
               c0(i,j) = SGS_ARM_SPL2(ng, wrk(1), nre, wrk(ire), &
                    wrk(ic), log_gamma, log_ret)
               
               c0mean = c0mean + c0(i,j)
               
            ELSE
               c0(i,j) = C_1_R
            ENDIF
         
            c0min = MIN(c0min, c0(i,j))
            c0max = MAX(c0max, c0(i,j))

         ENDDO
      ENDDO

      IF ( ipr .EQ. 1 ) THEN
         IF ( ihit .GT. 0 ) THEN
            c0mean = c0mean/ihit
         ENDIF
     
!     WRITE(line,111) ihit, remin, remax, gmin, gmax, 
! $        c0min, c0max, c0mean
! 111     FORMAT((I5,3X),7(1X,E10.3))
         dum = M_REAL(ihit)/M_REAL(imax*jmax)
         WRITE(line,111) dum, remin, remax, &
              gmin, gmax, c0max
 111     FORMAT(F6.4,2X,5(1X,E10.3))
         CALL CLIP(line,l1,l2)
         messageles = messageles(1:LEN_TRIM(messageles))//'   '//line(l1:l2)
      ENDIF

      RETURN
      END
