! #############################################
! # Adhoc 2D spectrum
! #
! # p(1) - p1
! # p(2) - p2 
! # ...
! #
! #############################################

      FUNCTION ESP_A2D(x, p)

      IMPLICIT NONE

#include "types.h"

      TREAL x, p(*)
      TREAL ESP_A2D, ESP_A_MOD

      TREAL A,B,ABSERR,EPSABS,EPSREL,FUN
      TREAL WORK
      TINTEGER IER,NEVAL
      TINTEGER IWORK,KEY,LAST,LENW,LIMIT
      DIMENSION WORK(400), IWORK(100)

      EXTERNAL ESP_A_MOD

! Integration and Iteration constants
      EPSABS = C_1EM8_R
      EPSREL = C_1EM8_R
      KEY = 6
      LIMIT = 100
      LENW = LIMIT*4
! Limits from matlab
      A = C_01_R
      B = C_100_R

      IF ( x .LT. C_01_R ) THEN
         p(10) = C_01_R
         CALL QUADAG(ESP_A_MOD,p,A,B,EPSABS,EPSREL,KEY,FUN,&
              ABSERR,NEVAL,IER,LIMIT,LENW,LAST,IWORK,WORK)
         ESP_A2D = p(10)*FUN
         ESP_A2D = ESP_A2D/p(10)*x
      ELSE
         p(10) = x
         CALL QUADAG(ESP_A_MOD,p,A,B,EPSABS,EPSREL,KEY,FUN,&
              ABSERR,NEVAL,IER,LIMIT,LENW,LAST,IWORK,WORK)
         ESP_A2D = x*FUN
      ENDIF
         
      RETURN
      END

! #############################################

      FUNCTION ESP_A_MOD(x, p)

      IMPLICIT NONE

#include "types.h"

      TREAL x, p(*)
      TREAL F, eta, xmod
      TREAL ESP_A_MOD

      xmod = SQRT(x*x+p(10)*p(10))

      eta = xmod*EXP(-C_3_R/C_4_R*LOG(p(4)))

      F = p(6)/(xmod+p(3))**p(7)*EXP(-p(2)*eta**p(8))

      ESP_A_MOD = ( xmod*p(7)/(xmod+p(3)) + p(8)*p(2)*eta**p(8) ) * F 

      ESP_A_MOD = ESP_A_MOD/(xmod*xmod)

      RETURN
      END

! ##################################################

      FUNCTION ESP_A2D_A0(x, params)

      IMPLICIT NONE

#include "types.h"

      TREAL x, params(*)
      TREAL G, S, norm
      TREAL FIL_1, ESP_A2D, ESP_A2D_A0

      S = params(9)*x
      G = FIL_1(S)
      norm = ESP_A2D(C_1_R/params(9),params)

      ESP_A2D_A0 = -ESP_A2D(x, params)&
           *(C_1_R-G*G)*(C_1_R-G*G)
      ESP_A2D_A0 = ESP_A2D_A0/norm

      RETURN
      END

! ##################################################

      FUNCTION ESP_A2D_A1(x, params)

      IMPLICIT NONE

#include "types.h"

      TREAL x, params(*)
      TREAL G, S, G2, norm
      TREAL FIL_1, ESP_A2D, ESP_A2D_A1

      S = params(9)*x
      G = FIL_1(S)
      norm = ESP_A2D(C_1_R/params(9),params)

      G2 = G*G
      ESP_A2D_A1 = C_2_R*ESP_A2D(x, params)*G2*&
           (C_1_R-G)*(C_1_R-G2)
      ESP_A2D_A1 = ESP_A2D_A1/norm

      RETURN
      END

! ##################################################

      FUNCTION ESP_A2D_A2(x, params)

      IMPLICIT NONE

#include "types.h"

      TREAL x, params(*)
      TREAL G, S, G2, norm
      TREAL FIL_1, ESP_A2D, ESP_A2D_A2

      S = params(9)*x
      G = FIL_1(S)
      norm = ESP_A2D(C_1_R/params(9),params)
      
      G2 = G*G
      ESP_A2D_A2 = ESP_A2D(x, params)&
           *G2*(C_1_R-G)*(C_1_R-G)*(C_1_R-G2)
      ESP_A2D_A2 = ESP_A2D_A2/norm

      RETURN
      END

! ##################################################
