SUBROUTINE CGBC2RSCNU(imax, jmax, kmax, kmax_total, dx, dy, dz, rhs)

#include "types.h"

#ifdef PARALLEL
  USE DNS_MPI
#endif

  IMPLICIT NONE

#ifdef PARALLEL
#include "mpif.h"
#endif

  TINTEGER imax
  TINTEGER jmax
  TINTEGER kmax
  TINTEGER kmax_total
  TREAL dx(imax)
  TREAL dy(jmax)
  TREAL dz(kmax_total)
  TINTEGER i
  TINTEGER j
  TINTEGER k, kp
  TREAL diag
  TREAL rhs(imax,jmax,kmax)

  DO k=1, kmax
#ifdef PARALLEL
     kp = ims_offset_k + k
#else 
     kp = k
#endif
     DO j=1, jmax
        DO i=1, imax
           diag = C_2_R*(C_1_R/dx(i)**2 &
                + C_1_R/dy(j)**2)

           IF ( kmax_total .GT. 1 ) THEN
              diag = diag + C_2_R/dz(kp)**2
           ENDIF

           rhs(i,j,k) = rhs(i,j,k)/diag
        ENDDO
     ENDDO
  ENDDO

  RETURN
END SUBROUTINE CGBC2RSCNU
