SUBROUTINE BRKSHTE(len, zeta, T, WMN, rho)
  
! This subroutine calculated the Burke-Schumman Temperature.
! It assumes a two stream system with enthalpies HOX and HFUEL.
  
#include "types.h"

  USE DNS_GLOBAL

  IMPLICIT NONE

  TINTEGER len
  TREAL zeta(len)
  TREAL T(len)
  TREAL WMN(len)
  TREAL rho(len)

  TREAL HE, CHW_ERROR, CHW_INC, CHW_RCOI
  TINTEGER is, im, icp
  TINTEGER i

  T(1) = C_1_R

  DO i=1, len

#define MACRO_ZINPUT zeta(i)
#include "dns_chem_mass.h"

     HE = (HOX + (HFUEL-HOX)*zeta(i))

#define MACRO_TINPUT T(i)
#define MACRO_HINPUT HE
#include "dns_chem_inv.h"

! ###################################################################
     WMN(i) = WMEAN

! Density
     rho(i) = MRATIO*p_init*WMEAN/T(i)
  ENDDO

  RETURN
END SUBROUTINE BRKSHTE
