#include "types.h"

MODULE CHEM_GLOBAL
  USE DNS_GLOBAL, ONLY : MAX_NSP

  IMPLICIT NONE
  SAVE

  TINTEGER, PARAMETER :: REAC_MAX = 100 ! Reactions of mechanism

! ################################################################      
  TREAL, DIMENSION(MAX_NSP) :: YMASSP, CST, NUP, NUPP
  TREAL                        CPW, CH_F, CH_G, CH_H, CHW_CE
  TREAL                        CHW_ETA0, CHW_ETA1, CHW_LN0, CHW_LN1, CHW_DHALF
  TREAL                        CHW_T, CHW_CP, CHW_ETA, CHW_HETA, CHW_HI, CHW_CPTOTAL
  TREAL                        NU, XIST, YOX, YFUEL, TGFM, HOX, HFUEL, TFLAME

  TINTEGER                      :: imech_type, ichem_config, ichem_normalized, NMECH
  CHARACTER*128                 :: mech_file, flame_ini_file
  TREAL,    DIMENSION(REAC_MAX) :: mech_pre, mech_beta, mech_tac, mech_order
  TINTEGER, DIMENSION(REAC_MAX) :: mech_number, rate_type

! -------------------------------------------------------------------
! Pilot
! -------------------------------------------------------------------
  TREAL    :: rjet_pilot_thickness, rjet_pilot_maxtratio, rjet_pilot_velocity
  TINTEGER :: ijet_pilot
  
END MODULE CHEM_GLOBAL
