      SUBROUTINE CORR1V2PTZ(imax, jmax, kmax, j, dx, dz, u, ruz, &
           luz, area, wc, wrk)

      IMPLICIT NONE

#include "types.h"
#ifdef PARALLEL
#include "mpif.h"
#endif

      TINTEGER i, j, k, id, index
      TINTEGER imax, jmax, kmax
      TREAL dx(imax), dz(kmax)
      TREAL u(imax, jmax, kmax)
      TREAL wc(imax, jmax, kmax)
      TREAL ruz(kmax/2+1)
      TREAL wrk(kmax/2+1)
      TREAL luz, area
      TREAL SIMPSON
      TINTEGER idmax, idratio
      TINTEGER ijd, idlocalmax, idlocal
#ifdef PARALLEL
      INTEGER ims_pro, ims_err
#endif

      IF ( kmax .EQ. 1 ) RETURN

#ifdef PARALLEL
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,ims_pro,ims_err)
#endif

      idmax = kmax/2 + 1
      idratio = idmax/jmax
      
      DO ijd = 0, idratio
         
         IF ( ijd .EQ. idratio ) THEN
            idlocalmax = MOD(idmax,jmax)
         ELSE
            idlocalmax = jmax
         ENDIF
         
         DO idlocal = 1, idlocalmax
            
            id = ijd*jmax+idlocal

            DO k=1, kmax
               index = k+id-2
               DO i=1, imax
                  wc(i,idlocal,k) = u(i,j,k)*&
                       u(i,j,MOD(index,kmax)+1)
               ENDDO    
            ENDDO
         ENDDO  
         CALL AVG_IK_V(imax, jmax, kmax, idlocalmax, &
              wc, dx, dz, ruz(ijd*jmax+1), wrk, area)
      ENDDO

#ifdef PARALLEL
      IF ( ims_pro .EQ. 0 ) THEN
#endif

      IF ( ruz(1) .NE. C_0_R ) THEN
         luz = SIMPSON(idmax, ruz, dz)/ruz(1)
         DO id=2,idmax
            ruz(id) = ruz(id)/ruz(1)
         ENDDO
         ruz(1) = C_1_R
      ELSE
         luz = C_0_R
      ENDIF

#ifdef PARALLEL
      ENDIF
#endif

      RETURN
      END
