SUBROUTINE CORRZ_SPA(nvar, ntimes, kmax, nstatlin, delta_z,&
     statlin_i, statlin_j, t_dat, l_dat, crl, wrk1d)
  
! #
! # IT IS NOT PARALLELIZED YET
! #
  
  IMPLICIT NONE

#include "types.h"

  TINTEGER nvar, ntimes, kmax, nstatlin

  TREAL delta_z 

  TREAL t_dat(2,ntimes)
  TREAL l_dat(ntimes,nstatlin,nvar,kmax)

  TINTEGER statlin_i(nstatlin), statlin_j(nstatlin)

  TREAL crl(kmax,nvar,nstatlin)
  TREAL wrk1d(kmax,*)

  TINTEGER i,j,k,n,it,itime
!  TREAL sum
  TREAL zloc
  CHARACTER*32 filename

  IF ( kmax .EQ. 1 ) RETURN

! Enter with mean equal to zero
! ###################
! # Remove the mean #
! ###################
!
!  DO i = 1,nvar
!     DO n = 1,nstatlin
!
!        sum = C_0_R
!        DO k = 1,kmax
!           DO it = 1,ntimes
!              sum = sum + l_dat(it,n,i,k)
!           ENDDO
!        ENDDO
!        sum = sum/M_REAL(kmax*ntimes)
!
!        DO it = 1,ntimes
!           DO k = 1,kmax
!              l_dat(it,n,i,k) = l_dat(it,n,i,k) - sum
!           ENDDO
!        ENDDO
!        
!     ENDDO
!  ENDDO

! #############################
! # Calculate autocorrelation #
! #############################

  DO k = 1,kmax*nvar*nstatlin
     crl(k,1,1) = C_0_R
  ENDDO

  DO it = 1,ntimes
     DO n = 1,nstatlin
        DO i = 1,nvar
           DO k = 1,kmax
              wrk1d(k,2) = l_dat(it,n,i,k)
           ENDDO
           CALL CORR1DP ( kmax, wrk1d(1,2), wrk1d(1,2),&
                wrk1d(1,1) )
           DO k = 1,kmax
              crl(k,i,n) = crl(k,i,n) + wrk1d(k,1)
           ENDDO
        ENDDO
     ENDDO
  ENDDO

  DO k = 1,kmax*nvar*nstatlin
     crl(k,1,1) = crl(k,1,1)/M_REAL(ntimes)
  ENDDO

! ###############
! # Tkstat file #
! ###############

  itime = INT(t_dat(1,ntimes))
  WRITE(filename,*) itime; filename = 'zcr'//TRIM(ADJUSTL(filename))

  OPEN(unit=23,file=filename)
  WRITE(23, *) 'RTIME = ', t_dat(2,ntimes)
  WRITE(23, *) 'I J rz Cuu(z) Cvv(z) Cww(z) Cpp(z) Crr(z) Css(z)'

  DO n = 1,nstatlin
     i = statlin_i(n)
     j = statlin_j(n)
     DO k = 1, kmax
        zloc = M_REAL(k-1)*delta_z
        WRITE(23,1020) i, j, zloc, &
             crl(k,1,n), crl(k,2,n), crl(k,3,n), &
             crl(k,4,n), crl(k,5,n), crl(k,6,n)
     ENDDO
  ENDDO

  CLOSE(23)

  RETURN

1020 FORMAT(I3,1X,I3,8(1X,E12.5E3))

END SUBROUTINE CORRZ_SPA

