SUBROUTINE LES_AVG_SPATIAL_LAYER(itxc, x, y, mean1d, txc, wrk1d, wrk2d)
  
#include "types.h"
#include "avgij_map.h"
#include "les_const.h"
#include "les_avgij_map.h"

  USE DNS_GLOBAL
  USE LES_GLOBAL

  IMPLICIT NONE

  TINTEGER itxc
  TREAL x(imax)
  TREAL y(jmax)
  TREAL mean1d(nstatavg,jmax,*)
  TREAL txc(*)
  TREAL wrk1d(nstatavg,*)
  TREAL wrk2d(nstatavg,jmax,*)

  TINTEGER pl, is

#ifdef TRACE_ON
  CALL IO_WRITE_ASCII(tfile, 'ENTERING LES_CALC_AVG' )
#endif

  pl = 1+MA_MOMENTUM_SIZE+MS_SCALAR_SIZE*inb_scal

  IF ( ilesstat_maj_ver .EQ. 1 ) THEN
     IF ( ilesstat_min_ver .EQ. 0 ) THEN
        CALL LESAVG_V1_0(itxc, x, y, mean1d, mean1d(1,1,pl), txc, wrk1d, wrk2d)
        IF ( icalc_scal .EQ. 1 ) THEN
           DO is = 1,inb_scal
              CALL LESSCBDG_V1_0(is, itxc, x, y, mean1d,&
                   mean1d(1,1,1 +MA_MOMENTUM_SIZE+MS_SCALAR_SIZE*(is-1)),&
                   mean1d(1,1,pl+LA_MOMENTUM_SIZE+LS_SCALAR_SIZE*(is-1)),&
                   mean1d(1,1,pl+LA_MOMENTUM_SIZE+LS_SCALAR_SIZE*inb_scal+LC_CHEM_SIZE*(is-1)),&
                   txc, wrk1d, wrk2d)
           ENDDO
        ENDIF

     ELSE IF ( ilesstat_min_ver .EQ. 1 ) THEN
        CALL LESAVG_V1_1(itxc, x, y, mean1d, mean1d(1,1,pl), txc, wrk1d, wrk2d)
        IF ( icalc_scal .EQ. 1 ) THEN
           DO is = 1,inb_scal
              CALL LESSCBDG_V1_1(is, itxc, x, y, mean1d,&
                   mean1d(1,1,1 +MA_MOMENTUM_SIZE+MS_SCALAR_SIZE*(is-1)),&
                   mean1d(1,1,pl+LA_MOMENTUM_SIZE+LS_SCALAR_SIZE*(is-1)),&
                   txc, wrk1d, wrk2d)
              IF ( iles_type_chem .EQ. LES_CHEM_STAT_BS   .OR. &
                   iles_type_chem .EQ. LES_CHEM_STAT_PS ) THEN
                 CALL LESCHEM_V1_1(is, itxc, x, y, mean1d,&
                      mean1d(1,1,1 +MA_MOMENTUM_SIZE+MS_SCALAR_SIZE*(is-1)),&
                      mean1d(1,1,pl+LA_MOMENTUM_SIZE+LS_SCALAR_SIZE*(is-1)),&
                      mean1d(1,1,pl+LA_MOMENTUM_SIZE+LS_SCALAR_SIZE*inb_scal+LC_CHEM_SIZE*(is-1)),&
                      txc, wrk1d, wrk2d)
              ENDIF
           ENDDO
        ENDIF

     ELSE IF ( ilesstat_min_ver .EQ. 2 ) THEN
        CALL LESAVG_V1_2(itxc, x, y, mean1d, mean1d(1,1,pl), txc, wrk1d, wrk2d)
        IF ( icalc_scal .EQ. 1 ) THEN
           DO is = 1,inb_scal
              CALL LESSCBDG_V1_1(is, itxc, x, y, mean1d, &
                   mean1d(1,1,1 +MA_MOMENTUM_SIZE+MS_SCALAR_SIZE*(is-1)), &
                   mean1d(1,1,pl+LA_MOMENTUM_SIZE+LS_SCALAR_SIZE*(is-1)), txc, wrk1d, wrk2d)
              IF ( iles_type_chem .EQ. LES_CHEM_STAT_BS .OR.&
                   iles_type_chem .EQ. LES_CHEM_STAT_PS ) THEN
                 CALL LESCHEM_V1_1(is, itxc, x, y, mean1d,&
                      mean1d(1,1,1 +MA_MOMENTUM_SIZE+MS_SCALAR_SIZE*(is-1)),&
                      mean1d(1,1,pl+LA_MOMENTUM_SIZE+LS_SCALAR_SIZE*(is-1)),&
                      mean1d(1,1,pl+LA_MOMENTUM_SIZE+LS_SCALAR_SIZE*inb_scal+LC_CHEM_SIZE*(is-1)),&
                      txc, wrk1d, wrk2d)
              ENDIF
           ENDDO
        ENDIF
     ENDIF
  ENDIF

#ifdef TRACE_ON
  CALL IO_WRITE_ASCII(tfile, 'LEAVING LES_CALC_AVG' )
#endif

  RETURN
END SUBROUTINE LES_AVG_SPATIAL_LAYER
