      SUBROUTINE SGS_DYN_NORMAL3(idir, ssmflg, n0, n1, 
     $     dx, dy, dz, rho, u, sij, barsij, barvs, frc, sfij, 
     $     dilatation, txc, wrk1d, 
     $     wrk2d, wrk3d, cf0x, cf0y, cf0z, cf1x, cf1y, cf1z, 
     $     cf2x, cf2y, cf2z, carm_uf, carm_uh)

c ###############################
c # frc1 is LHSF
c # frc2 is NFSF
c # frc3 is NHSF
c # dilatation1 1/3*dil
c # dilatation2 1/3*bardil
c #
c # txc - required size of 2 if ssmflg is 0
c # txc - required size of 3 if ssmflg is 1
c #
c ###############################

      IMPLICIT NONE

#include "types.h"
#include "common.h"

      TINTEGER idir, ssmflg, n0, n1

      TREAL dx(imax)
      TREAL dy(jmax)
      TREAL dz(kmax_total)
      TREAL rho(imax,jmax,kmax)
      TREAL u(imax,jmax,kmax)

      TREAL sij(imax,jmax,kmax)
      TREAL barsij(imax,jmax,kmax)
      TREAL barvs(imax,jmax,kmax,*)
      TREAL frc(imax,jmax,kmax,3)
      TREAL sfij(imax,jmax,kmax)
      TREAL dilatation(imax,jmax,kmax,2)
      TREAL txc(imax,jmax,kmax,*)

      TREAL wrk1d(ijkmax,*)
      TREAL wrk2d(ijmax,*)
      TREAL wrk3d(imax,jmax,kmax)
      TREAL cf0x(*), cf0y(*), cf0z(*)
      TREAL cf1x(*), cf1y(*), cf1z(*)
      TREAL cf2x(*), cf2y(*), cf2z(*)
      TREAL carm_uf(*), carm_uh(*)

      TINTEGER ij, k, i, j
      TREAL mean, AVG_IK
      TINTEGER i0, i1, i3

      i0 = 0
      i1 = 1
      i3 = 3

#define LHSF(i,j,k)   frc(i,j,k,1)
#define NFSF(i,j,k)   frc(i,j,k,2)
#define NHSF(i,j,k)   frc(i,j,k,3)

c ############################
c # Calculate Sij at level F #
c ############################
      IF ( idir .EQ. 1 ) THEN
         CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc,
     $        dx, u, sfij, i0, i0,
     $        wrk1d, wrk2d, wrk3d)
      ELSE IF ( idir .EQ. 2 ) THEN
         CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc,
     $        dy, u, sfij, i0, i0,
     $        wrk1d, wrk2d, wrk3d)
      ELSE
         CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc,
     $        dz, u, sfij, i0, i0,
     $        wrk1d, wrk2d, wrk3d)
      ENDIF

c ####################      
c # Calculate NiiSii #
c ####################
c -------------------------------------------------------------
c                                              level H, N_H:S_F
c -------------------------------------------------------------
      DO k = 1,kmax
         DO ij = 1,NN
            txc(ij,1,k,1) = rho(ij,1,k)*u(ij,1,k)
         ENDDO
      ENDDO
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
     $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
     $     n1, cf1x, cf1y, cf1z, txc(1,1,1,1), txc(1,1,1,2), wrk3d)
      DO k = 1,kmax
         DO ij = 1,NN
            txc(ij,1,k,2) = txc(ij,1,k,2)*barvs(ij,1,k,1)
         ENDDO
      ENDDO
      IF ( idir .EQ. 1 ) THEN
         CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc,
     $        dx, txc(1,1,1,2), txc(1,1,1,1), i0, i0,
     $        wrk1d, wrk2d, wrk3d)
      ELSE IF ( idir .EQ. 2 ) THEN
         CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc,
     $        dy, txc(1,1,1,2), txc(1,1,1,1), i0, i0,
     $        wrk1d, wrk2d, wrk3d)
      ELSE
         CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc,
     $        dz, txc(1,1,1,2), txc(1,1,1,1), i0, i0,
     $        wrk1d, wrk2d, wrk3d)
      ENDIF
c      IF ( sgs_devsmag .EQ. 1 ) THEN
c         DO k=1,kmax
c            DO ij=1,NN
c               mij(ij,1,k) = (txc(ij,1,k,1)-dilatation(ij,1,k,2))*
c     $              barsij(ij,1,k)*coefdelta
c            ENDDO
c         ENDDO
c      ELSE
         DO k=1,kmax
            DO ij=1,NN
               txc(ij,1,k,1) = txc(ij,1,k,1)*barsij(ij,1,k)
            ENDDO
         ENDDO
c      ENDIF

      DO j = 1,jmax
         mean = AVG_IK(imax, jmax, kmax, j, txc(1,1,1,1), dx, dz, area)
         DO k = 1,kmax
            DO i = 1,imax
               NHSF(i,j,k) = NHSF(i,j,k) + 
     $              (txc(i,j,k,1)-mean)*sfij(i,j,k)
            ENDDO
         ENDDO
      ENDDO      

c -------------------------------------------------------------
c                                         level F, bar(N_F):S_F
c -------------------------------------------------------------
      IF ( idir .EQ. 1 ) THEN
         CALL PARTIAL_X(isord, imax, jmax, kmax, i1bc,
     $        dx, u, txc(1,1,1,1), i0, i0,
     $        wrk1d, wrk2d, wrk3d)
      ELSE IF ( idir .EQ. 2 ) THEN
         CALL PARTIAL_Y(isord, imax, jmax, kmax, j1bc,
     $        dy, u, txc(1,1,1,1), i0, i0,
     $        wrk1d, wrk2d, wrk3d)
      ELSE
         CALL PARTIAL_Z(isord, imax, jmax, kmax, k1bc,
     $        dz, u, txc(1,1,1,1), i0, i0,
     $        wrk1d, wrk2d, wrk3d)
      ENDIF
c      IF ( sgs_devsmag .EQ. 1 ) THEN
c         DO k=1,kmax
c            DO ij=1,NN
c               txc(ij,1,k,1) = (txc(ij,1,k,1)-dilatation(ij,1,k,1))*
c     $              sij(ij,1,k)
c            ENDDO
c         ENDDO
c      ELSE
         DO k=1,kmax
            DO ij=1,NN
               txc(ij,1,k,1) = txc(ij,1,k,1)*sij(ij,1,k)
            ENDDO
         ENDDO
c      ENDIF
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
     $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
     $     n1, cf1x, cf1y, cf1z, txc(1,1,1,1), txc(1,1,1,2), wrk3d)

      DO j = 1,jmax
         mean = AVG_IK(imax, jmax, kmax, j, txc(1,1,1,2), dx, dz, area)
         DO k = 1,kmax
            DO i = 1,imax
               NFSF(i,j,k) = NFSF(i,j,k) + 
     $              (txc(i,j,k,2)-mean)*sfij(i,j,k)
            ENDDO
         ENDDO
      ENDDO      
c      DO k=1,kmax
c         DO ij=1,NN
c            frc(ij,1,k,2) = frc(ij,1,k,2) + txc(ij,1,k,2)*sfij(ij,1,k)
c         ENDDO
c      ENDDO

c ####################      
c # Calculate LiiSii #
c ####################
      DO k=1,kmax
         DO ij=1,NN
            txc(ij,1,k,1) = u(ij,1,k)*u(ij,1,k)*rho(ij,1,k)
         ENDDO
      ENDDO
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
     $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
     $     n1, cf1x, cf1y, cf1z, txc(1,1,1,1), txc(1,1,1,2), wrk3d)
      DO k=1,kmax
         DO ij=1,NN
            LHSF(ij,1,k) = LHSF(ij,1,k) + 
     $           sfij(ij,1,k)*txc(ij,1,k,2)
         ENDDO
      ENDDO

      DO k=1,kmax
         DO ij=1,NN
            txc(ij,1,k,1) = u(ij,1,k)*rho(ij,1,k)
         ENDDO
      ENDDO
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
     $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
     $     n1, cf1x, cf1y, cf1z, txc(1,1,1,1), txc(1,1,1,2), wrk3d)
      DO k=1,kmax
         DO ij=1,NN
            LHSF(ij,1,k) = LHSF(ij,1,k) - sfij(ij,1,k)*
     $           txc(ij,1,k,2)*txc(ij,1,k,2)*barvs(ij,1,k,1)
         ENDDO
      ENDDO
      
c ####################
c # Calculate HiiSii #
c ####################
      IF ( ssmflg .EQ. 1 ) THEN
         CALL SGS_DYN_HIJ(i1, n0, n1, rho, u, u, barvs, 
     $        LHSF(1,1,1), sfij, txc,
     $        wrk1d, wrk2d, wrk3d, cf0x, cf0y, cf0z, cf1x, cf1y, cf1z, 
     $        cf2x, cf2y, cf2z, carm_uf, carm_uh, carm_uf, carm_uh)
      ENDIF

#undef LHSH
#undef NFSH
#undef NHSH

      RETURN
      END
      
