SUBROUTINE SGS_DYN_ARM_U(n0, n1, x, y, z, dx, dy, dz, &
     rho, u, v, w, barvs, txc, wrk1d, wrk2d, wrk3d, cf0x, cf0y, cf0z,&
     cf1x, cf1y, cf1z, cf2x, cf2y, cf2z, carm_uf, carm_uh)

  ! # barvs(1) = 1/bar1(bar0(rho))          
  ! # barvs(2) = 1/bar0(bar0(rho))             
  ! # barvs(3) = 1/bar1(bar0(bar1(bar0(rho)))) 

  ! txc size is 6

  USE DNS_GLOBAL
  USE LES_GLOBAL

  IMPLICIT NONE

#include "types.h"
#include "les_const.h"
#include "integers.h"

  TINTEGER n0, n1
  TREAL dx(imax)
  TREAL dy(jmax)
  TREAL dz(kmax_total)
  TREAL x(imax)
  TREAL y(jmax)
  TREAL z(kmax_total)
  TREAL rho(imax,jmax,kmax)
  TREAL u(imax,jmax,kmax)
  TREAL v(imax,jmax,kmax)
  TREAL w(imax,jmax,kmax)
  TREAL barvs(imax,jmax,kmax,*)
  TREAL wrk1d(isize_wrk1d,*)
  TREAL wrk2d(*)
  TREAL wrk3d(imax,jmax,kmax)
  TREAL txc(imax,jmax,kmax,*)
  TREAL cf0x(*), cf0y(*), cf0z(*)
  TREAL cf1x(*), cf1y(*), cf1z(*)
  TREAL cf2x(*), cf2y(*), cf2z(*)
  TREAL carm_uf(*), carm_uh(*)

  TINTEGER ij, j, k
  TREAL r0
  !  TREAL SIMPSON_NU, a0_int, a1_int, a2_int, c0_int

  r0 = C_0_R

#define RHOK_SG(j)  wrk1d(j,1)
#define A0(j)       wrk1d(j,2)
#define A1(j)       wrk1d(j,3)
#define A2(j)       wrk1d(j,4)
#define A0_LOC(j)   wrk1d(j,5)
#define A1_LOC(j)   wrk1d(j,6)
#define A2_LOC(j)   wrk1d(j,7)

  !#define BARMU(i,j,k)    txc(i,j,k,1)
  !#define TMP1_LOC(i,j,k) txc(i,j,k,2)

  ! ARM inviscid
  IF ( iles_type_tran .EQ. LES_TRAN_ARMINVS ) THEN
     DO j = 1,jmax
        !         carm_uf(j) = arm_c0_inviscid
        carm_uh(j) = arm_c0_inviscid
     ENDDO

     ! ARM rans
  ELSE IF ( iles_type_tran .EQ. LES_TRAN_ARMRANS ) THEN
     ! ################################
     ! #    calculating c0 at level F #
     ! ################################
     !  IF ( iles_type_regu .EQ. LES_REGU_SMGDYNRMS ) THEN 
     !c ----------------------------------------------------------------
     !c                                 calculating average 2*<rho*K_sg>
     !c ----------------------------------------------------------------
     !c     Use from A0 as wrk1d array
     !     CALL SGS_ARM_RANS_USG(imax, jmax, kmax, kmax_total,
     ! $        area, rtime, x, y, z, dx, dy, dz, 
     ! $        rho, u, v, w, RHOK_SG(1), A0(1), wrk3d)
     !
     !c ----------------------------------------------------------------
     !c                                      calculating the coefficient
     !c ----------------------------------------------------------------
     !c     MU=rho*u
     !     DO k = 1,kmax
     !        DO ij = 1,imax*jmax
     !           BARMU(ij,1,k) = rho(ij,1,k)*u(ij,1,k)
     !        ENDDO
     !     ENDDO
     !c     txc size is 4
     !     CALL SGS_ARM_RANS_A(imax, jmax, kmax, kmax_total, n0,
     ! $        i1, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,
     ! $        dx, dy, dz, rho, barvs(1,1,1,2), 
     ! $        BARMU(1,1,1), RHOK_SG(1), 
     ! $        A0(1), A1(1), A2(1), 
     ! $        cf0x, cf0y, cf0z, TMP1_LOC(1,1,1), wrk3d)
     !     RHOK_SG(1:jmax) = C_0_R
     !c     MV=rho*v
     !     DO k = 1,kmax
     !        DO ij = 1,imax*jmax
     !           BARMU(ij,1,k) = rho(ij,1,k)*v(ij,1,k)
     !        ENDDO
     !     ENDDO
     !c     txc size is 4
     !     CALL SGS_ARM_RANS_A(imax, jmax, kmax, kmax_total, n0,
     ! $        i1, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,
     ! $        dx, dy, dz, rho, barvs(1,1,1,2), 
     ! $        BARMU(1,1,1), RHOK_SG(1), 
     ! $        A0_LOC(1), A1_LOC(1), A2_LOC(1), 
     ! $        cf0x, cf0y, cf0z, TMP1_LOC(1,1,1), wrk3d)
     !     DO j = 1,jmax
     !        A0(j) = A0(j) + A0_LOC(j)
     !        A1(j) = A1(j) + A1_LOC(j)
     !        A2(j) = A2(j) + A2_LOC(j)
     !     ENDDO
     !c     MW=rho*w
     !     DO k = 1,kmax
     !        DO ij = 1,imax*jmax
     !           BARMU(ij,1,k) = rho(ij,1,k)*w(ij,1,k)
     !        ENDDO
     !     ENDDO
     !c     txc size is 4
     !     CALL SGS_ARM_RANS_A(imax, jmax, kmax, kmax_total, n0,
     ! $        i1, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,
     ! $        dx, dy, dz, rho, barvs(1,1,1,2), 
     ! $        BARMU(1,1,1), RHOK_SG(1), 
     ! $        A0_LOC(1), A1_LOC(1), A2_LOC(1), 
     ! $        cf0x, cf0y, cf0z, TMP1_LOC(1,1,1), wrk3d)
     !     DO j = 1,jmax
     !        A0(j) = A0(j) + A0_LOC(j)
     !        A1(j) = A1(j) + A1_LOC(j)
     !        A2(j) = A2(j) + A2_LOC(j)
     !     ENDDO
     !
     !     CALL SGS_ARM_RANS_C0(jmax, A0(1), A1(1), 
     ! $        A2(1), carm_uf)
     !c         a0_int = SIMPSON_NU(jmax,A0(1),y)
     !c         a1_int = SIMPSON_NU(jmax,A1(1),y)
     !c         a2_int = SIMPSON_NU(jmax,A2(1),y)
     !c         CALL SGS_ARM_RANS_C0(i1, a0_int, a1_int, a2_int, c0_int)
     !c         DO j = 1,jmax
     !c            carm_uf(j) = c0_int
     !c         ENDDO
     !
     !  ENDIF
     !
     !#undef BARMU
     !#undef TMP1_LOC

#define R_H(i,j,k)      txc(i,j,k,1)
#define U_H(i,j,k)      txc(i,j,k,2)
#define V_H(i,j,k)      txc(i,j,k,3)
#define W_H(i,j,k)      txc(i,j,k,4)
#define TMP1_LOC(i,j,k) txc(i,j,k,5)

     ! ################################
     ! #    calculating c0 at level H #
     ! ################################
     ! ----------------------------------------------------------------
     !                             calculating average 2*<rho*K_sg>
     ! ----------------------------------------------------------------
     DO k = 1,kmax
        DO ij = 1,imax*jmax
           TMP1_LOC(ij,1,k) = rho(ij,1,k)*u(ij,1,k)
           U_H(ij,1,k) = rho(ij,1,k)*v(ij,1,k)
           V_H(ij,1,k) = rho(ij,1,k)*w(ij,1,k)
        ENDDO
     ENDDO
     CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
          iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
          n1, cf1x, cf1y, cf1z, V_H(1,1,1), &
          W_H(1,1,1), wrk3d)
     CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
          iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
          n1, cf1x, cf1y, cf1z, U_H(1,1,1), &
          V_H(1,1,1), wrk3d)
     CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
          iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
          n1, cf1x, cf1y, cf1z, TMP1_LOC(1,1,1), &
          U_H(1,1,1), wrk3d)
     CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
          iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
          n1, cf1x, cf1y, cf1z, rho, &
          R_H(1,1,1), wrk3d)
     DO k = 1,kmax
        DO ij = 1,imax*jmax
           U_H(ij,1,k) = U_H(ij,1,k)/R_H(ij,1,k)
           V_H(ij,1,k) = V_H(ij,1,k)/R_H(ij,1,k)
           W_H(ij,1,k) = W_H(ij,1,k)/R_H(ij,1,k)
        ENDDO
     ENDDO
     ! Use from A0 as wrk1d array
     CALL SGS_ARM_RANS_USG(imax, jmax, kmax, kmax_total,&
          area, rtime, x, y, z, dx, dy, dz, &
          R_H(1,1,1), U_H(1,1,1), V_H(1,1,1), W_H(1,1,1), &
          RHOK_SG(1), A0(1), wrk3d)

#undef R_H
#undef U_H
#undef V_H
#undef W_H
#undef TMP1_LOC

#define BARMU(i,j,k)    txc(i,j,k,1)
#define TMP1_LOC(i,j,k) txc(i,j,k,2)
     ! ----------------------------------------------------------------
     !                                  calculating the coefficient
     ! ----------------------------------------------------------------
     ! MU=rho*u
     DO k = 1,kmax
        DO ij = 1,imax*jmax
           TMP1_LOC(ij,1,k) = rho(ij,1,k)*u(ij,1,k)
        ENDDO
     ENDDO
     CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
          iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
          n1, cf1x, cf1y, cf1z, TMP1_LOC(1,1,1), &
          BARMU(1,1,1), wrk3d)
     ! txc size is 4
     CALL SGS_ARM_RANS_A2(imax, jmax, kmax, kmax_total, &
          n0, n1,&
          i1, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,&
          dx, dy, dz, barvs(1,1,1,1), barvs(1,1,1,3), &
          BARMU(1,1,1), RHOK_SG(1), &
          A0(1), A1(1), A2(1), cf2x, cf2y, cf2z, &
          TMP1_LOC(1,1,1), wrk3d)
     RHOK_SG(1:jmax) = C_0_R
     ! MV=rho*v
     DO k = 1,kmax
        DO ij = 1,imax*jmax
           TMP1_LOC(ij,1,k) = rho(ij,1,k)*v(ij,1,k)
        ENDDO
     ENDDO
     CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
          iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
          n1, cf1x, cf1y, cf1z, TMP1_LOC(1,1,1), &
          BARMU(1,1,1), wrk3d)
     ! txc size is 4
     CALL SGS_ARM_RANS_A2(imax, jmax, kmax, kmax_total, &
          n0, n1,&
          i1, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,&
          dx, dy, dz, barvs(1,1,1,1), barvs(1,1,1,3), &
          BARMU(1,1,1), RHOK_SG(1), &
          A0_LOC(1), A1_LOC(1), A2_LOC(1), cf2x, cf2y, cf2z, &
          TMP1_LOC(1,1,1), wrk3d)
     DO j = 1,jmax
        A0(j) = A0(j) + A0_LOC(j)
        A1(j) = A1(j) + A1_LOC(j)
        A2(j) = A2(j) + A2_LOC(j)
     ENDDO
     ! MW=rho*w
     DO k = 1,kmax
        DO ij = 1,imax*jmax
           TMP1_LOC(ij,1,k) = rho(ij,1,k)*w(ij,1,k)
        ENDDO
     ENDDO
     CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
          iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
          n1, cf1x, cf1y, cf1z, TMP1_LOC(1,1,1), &
          BARMU(1,1,1), wrk3d)
     ! txc size is 4
     CALL SGS_ARM_RANS_A2(imax, jmax, kmax, kmax_total, &
          n0, n1,&
          i1, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,&
          dx, dy, dz, barvs(1,1,1,1), barvs(1,1,1,3), &
          BARMU(1,1,1), RHOK_SG(1), &
          A0_LOC(1), A1_LOC(1), A2_LOC(1), cf2x, cf2y, cf2z, &
          TMP1_LOC(1,1,1), wrk3d)
     DO j = 1,jmax
        A0(j) = A0(j) + A0_LOC(j)
        A1(j) = A1(j) + A1_LOC(j)
        A2(j) = A2(j) + A2_LOC(j)
     ENDDO

     CALL SGS_ARM_RANS_C0(jmax, A0(1), A1(1), &
          A2(1), carm_uh)
     !     a0_int = SIMPSON_NU(jmax,A0(1),y)
     !     a1_int = SIMPSON_NU(jmax,A1(1),y)
     !     a2_int = SIMPSON_NU(jmax,A2(1),y)
     !     CALL SGS_ARM_RANS_C0(i1, a0_int, a1_int, a2_int, c0_int)
     !     DO j = 1,jmax
     !        carm_uh(j) = c0_int
     !     ENDDO

#ifdef _DEBUG
     CALL IO_WRITE_ASCII_FIELD('c0U_H.dat', i1, jmax, i1, carm_uh)
#endif

  ENDIF

#undef RHOK_SG
#undef A0
#undef A1
#undef A2
#undef A0_LOC
#undef A1_LOC
#undef A2_LOC

#undef BARMU
#undef TMP1_LOC

  RETURN
END SUBROUTINE SGS_DYN_ARM_U
