      SUBROUTINE SGS_DYN_ARM_P(n0, n1, x, y, z, dx, dy, dz, &
           rho, p, barvs, &
           txc, wrk1d, wrk2d, wrk3d, cf0x, cf0y, cf0z,&
           cf1x, cf1y, cf1z, cf2x, cf2y, cf2z, carm_pf, carm_ph)
      
! # barvs(1) = 1/bar1(bar0(rho))          
! # barvs(2) = 1/bar0(bar0(rho))             
! # barvs(3) = 1/bar1(bar0(bar1(bar0(rho)))) 

! txc size is 5

  USE DNS_GLOBAL
  USE LES_GLOBAL

      IMPLICIT NONE

#include "types.h"
#include "les_const.h"
#include "integers.h"

      TINTEGER n0, n1
      TREAL dx(imax)
      TREAL dy(jmax)
      TREAL dz(kmax_total)
      TREAL x(imax)
      TREAL y(jmax)
      TREAL z(kmax_total)
      TREAL rho(imax,jmax,kmax)
      TREAL p(imax,jmax,kmax)
      TREAL barvs(imax,jmax,kmax,*)
      TREAL wrk1d(isize_wrk1d,*)
      TREAL wrk2d(*)
      TREAL wrk3d(imax,jmax,kmax)
      TREAL txc(imax,jmax,kmax,*)
      TREAL cf0x(*), cf0y(*), cf0z(*)
      TREAL cf1x(*), cf1y(*), cf1z(*)
      TREAL cf2x(*), cf2y(*), cf2z(*)
      TREAL carm_pf(*), carm_ph(*)

      TINTEGER j
      TREAL r0, r1
!  TREAL SIMPSON_NU, a0_int, a1_int, a2_int, c0_int
      
      r0 = C_0_R
      r1 = C_1_R

#define P2_SG(j)     wrk1d(j,1)
#define A0(j)        wrk1d(j,2)
#define A1(j)        wrk1d(j,3)
#define A2(j)        wrk1d(j,4)

!#define TMP1_LOC(i,j,k) txc(i,j,k,1)

! ARM inviscid
      IF ( iles_type_tran .EQ. LES_TRAN_ARMINVS ) THEN
         DO j = 1,jmax
!        carm_pf(j) = arm_c0_inviscid
            carm_ph(j) = arm_c0_inviscid
         ENDDO

! ARM rans
      ELSE IF ( iles_type_tran .EQ. LES_TRAN_ARMRANS ) THEN
! ################################
! #    calculating c0 at level F #
! ################################
!  IF ( iles_type_regu .EQ. LES_REGU_SMGDYNRMS ) THEN 
!c ----------------------------------------------------------------
!c                                       calculating average <p_sg>
!c ----------------------------------------------------------------
!c     Use from A0 as wrk1d array
!     CALL SGS_ARM_RANS_PSG(imax, jmax, kmax, kmax_total,
! $        area, rtime, x, y, z, dx, dy, dz, 
! $        p, P2_SG(1), A0(1), wrk3d)
!
!c ----------------------------------------------------------------
!c                                      calculating the coefficient
!c ----------------------------------------------------------------
!c     txc size is 4
!     CALL SGS_ARM_RANS_A(imax, jmax, kmax, kmax_total, n0,
! $        i0, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,
! $        dx, dy, dz, rho, barvs(1,1,1,2), 
! $        p, P2_SG(1), A0(1), A1(1), A2(1), 
! $        cf0x, cf0y, cf0z, TMP1_LOC(1,1,1), wrk3d)
!     CALL SGS_ARM_RANS_C0(jmax, A0(1), A1(1), 
! $        A2(1), carm_pf)
!c         a0_int = SIMPSON_NU(jmax,A0(1),y)
!c         a1_int = SIMPSON_NU(jmax,A1(1),y)
!c         a2_int = SIMPSON_NU(jmax,A2(1),y)
!c         CALL SGS_ARM_RANS_C0(i1, a0_int, a1_int, a2_int, c0_int)
!c         DO j = 1,jmax
!c            carm_pf(j) = c0_int
!c         ENDDO
!
!  ENDIF
!
!#undef TMP1_LOC

#define P_H(i,j,k)      txc(i,j,k,1)
#define TMP1_LOC(i,j,k) txc(i,j,k,2)

! ################################
! #    calculating c0 at level H #
! ################################
! ----------------------------------------------------------------
!                                   calculating average <p_sg>
! ----------------------------------------------------------------
         CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n1, cf1x, cf1y, cf1z, p, &
              P_H(1,1,1), wrk3d)
         CALL SGS_ARM_RANS_PSG(imax, jmax, kmax, kmax_total,&
              area, rtime, x, y, z, dx, dy, dz, &
              P_H(1,1,1), P2_SG(1), A0(1), wrk3d)


#undef P_H
#undef TMP1_LOC

#define BARP(i,j,k)     txc(i,j,k,1)
#define TMP1_LOC(i,j,k) txc(i,j,k,2)
! ----------------------------------------------------------------
!                                  calculating the coefficient
! ----------------------------------------------------------------
         CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n1, cf1x, cf1y, cf1z, p, &
              BARP(1,1,1), wrk3d)
! txc size is 4
         CALL SGS_ARM_RANS_A2(imax, jmax, kmax, kmax_total, &
              n0, n1,&
              i0, iunifx, iunify, iunifz, i1bc, j1bc, k1bc, area,&
              dx, dy, dz, barvs(1,1,1,1), barvs(1,1,1,3),&
              BARP(1,1,1), P2_SG(1), &
              A0(1), A1(1), A2(1), cf2x, cf2y, cf2z, &
              TMP1_LOC(1,1,1), wrk3d)
         CALL SGS_ARM_RANS_C0(jmax, A0(1), A1(1), &
              A2(1), carm_ph)
!     a0_int = SIMPSON_NU(jmax,A0(1),y)
!     a1_int = SIMPSON_NU(jmax,A1(1),y)
!     a2_int = SIMPSON_NU(jmax,A2(1),y)
!     CALL SGS_ARM_RANS_C0(i1, a0_int, a1_int, a2_int, c0_int)
!     DO j = 1,jmax
!        carm_ph(j) = c0_int
!     ENDDO

#ifdef _DEBUG
         CALL IO_WRITE_ASCII_FIELD('c0P_H.dat', i1, jmax, i1, carm_ph)
#endif

      ENDIF

#undef P2_SG
#undef A0
#undef A1
#undef A2

#undef BARP
#undef TMP1_LOC

      RETURN
      END
