      SUBROUTINE SGS_DYN_PDIL(ii, statflg, x, y, z, dx, dy, dz, &
           rho, u, v, w, p, h4, &
           mean1d_les, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6,&
           tmp7, tmp8, wrk1d, wrk2d, wrk3d, &
           cf0x, cf0y, cf0z, cf1x, cf1y, cf1z, cf2x, cf2y, cf2z)

! #######################
! # tmp0 is dil( u )
! # tmp1 is dil( baru )
! #
! # tmp size is 9
! #######################

#include "types.h"
#include "dns_const.h"
#include "les_avgij_map.h"

  USE DNS_GLOBAL
  USE LES_GLOBAL

      IMPLICIT NONE

      TINTEGER ii, statflg

      TREAL x(imax)
      TREAL y(jmax)
      TREAL z(kmax_total)
      TREAL dx(imax)
      TREAL dy(jmax)
      TREAL dz(kmax_total)

      TREAL rho(imax, jmax, kmax)
      TREAL u(imax, jmax, kmax)
      TREAL v(imax, jmax, kmax)
      TREAL w(imax, jmax, kmax)
      TREAL p(imax, jmax, kmax)

      TREAL h4(imax, jmax, kmax)

      TREAL mean1d_les(nstatavg,jmax,*)

      TREAL tmp0(imax, jmax, kmax)
      TREAL tmp1(imax, jmax, kmax)
      TREAL tmp2(imax, jmax, kmax)
      TREAL tmp3(imax, jmax, kmax)
      TREAL tmp4(imax, jmax, kmax)
      TREAL tmp5(imax, jmax, kmax)
      TREAL tmp6(imax, jmax, kmax)
      TREAL tmp7(imax, jmax, kmax)
      TREAL tmp8(imax, jmax, kmax)
      
      TREAL wrk1d(isize_wrk1d,*)
      TREAL wrk2d(isize_wrk2d,*)
      TREAL wrk3d(imax,jmax,kmax)
      TREAL cf0x(*), cf0y(*), cf0z(*)
      TREAL cf1x(*), cf1y(*), cf1z(*)
      TREAL cf2x(*), cf2y(*), cf2z(*)
      
      TREAL AVG_IK, dummax
      TINTEGER ij, i, j, k, n0, n1, offset
      TINTEGER i0, i1, i2, i3, i5, i6, i7

      i0 = 0
      i1 = 1
      i2 = 2
      i3 = 3
      i5 = 5
      i6 = 6
      i7 = 7

      n0 = isgs_f0size
      n1 = isgs_f1size

#ifdef TRACE_ON
      CALL IO_WRITE_ASCII(tfile, 'ENTERING SGS_DYN_PDIL' )
#endif

! ########################################
! # divergence of lower level of filter: #
! # - tmp0 is div( u )                   #
! # - tmp1 is div( baru )                #
! ########################################
! tmp1 is dil( baru )
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp4(ij,1,k) = tmp0(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO
      CALL PARTIAL_X(imode_fdm, imax, jmax, kmax, i1bc, dx, tmp4, tmp1, &
           i0, i0, wrk1d, wrk2d, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp4(ij,1,k) = tmp0(ij,1,k)*tmp2(ij,1,k)
         ENDDO
      ENDDO
      CALL PARTIAL_Y(imode_fdm, imax, jmax, kmax, j1bc, dy, tmp4, tmp2, &
           i0, i0, wrk1d, wrk2d, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp4(ij,1,k) = tmp0(ij,1,k)*tmp3(ij,1,k)
         ENDDO
      ENDDO
      CALL PARTIAL_Z(imode_fdm, imax, jmax, kmax, k1bc, dz, tmp4, tmp3, &
           i0, i0, wrk1d, wrk2d, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp1(ij,1,k) = tmp1(ij,1,k)+tmp2(ij,1,k)+tmp3(ij,1,k)
         ENDDO
      ENDDO
! tmp0 is div( u )
      CALL PARTIAL_X(imode_fdm, imax, jmax, kmax, i1bc, dx, u, tmp2, &
           i0, i0, wrk1d, wrk2d, wrk3d)
      CALL PARTIAL_Y(imode_fdm, imax, jmax, kmax, j1bc, dy, v, tmp3, &
           i0, i0, wrk1d, wrk2d, wrk3d)
      CALL PARTIAL_Z(imode_fdm, imax, jmax, kmax, k1bc, dz, w, tmp4, &
           i0, i0, wrk1d, wrk2d, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp0(ij,1,k) = tmp2(ij,1,k)+tmp3(ij,1,k)+tmp4(ij,1,k)
         ENDDO
      ENDDO

! #########################################
! # divergence of higher level of filter: #
! # - tmp2 is div( wtb(u) )               #
! # - tmp3 is div( wtb(wtb(u)) )          #
! #########################################

! density
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n1, cf1x, cf1y, cf1z, rho, tmp4, wrk3d)
!  IF ( iles_mpitype .EQ. 0 ) THEN
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n0, cf0x, cf0y, cf0z, tmp4, wrk3d, tmp5)
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n1, cf1x, cf1y, cf1z, wrk3d, tmp5, tmp6)
!  ELSE
         CALL FILTH2(i3, imax, jmax, kmax, kmax_total,&
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n0, n1, cf2x, cf2y, cf2z, tmp4, tmp5, wrk3d)
!  ENDIF
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp4(ij,1,k) = C_1_R/tmp4(ij,1,k)
            tmp5(ij,1,k) = C_1_R/tmp5(ij,1,k)
         ENDDO
      ENDDO

! component u
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp6(ij,1,k) = rho(ij,1,k)*u(ij,1,k)
         ENDDO
      ENDDO
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n0, cf0x, cf0y, cf0z, tmp6, tmp7, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp6(ij,1,k) = tmp4(ij,1,k)*tmp7(ij,1,k)
         ENDDO
      ENDDO
      CALL PARTIAL_X(imode_fdm, imax, jmax, kmax, i1bc, dx, tmp6, tmp2, &
           i0, i0, wrk1d, wrk2d, wrk3d)
!  IF ( iles_mpitype .EQ. 0 ) THEN
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n0, cf0x, cf0y, cf0z, tmp7, wrk3d, tmp6)
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n1, cf1x, cf1y, cf1z, wrk3d, tmp6, tmp7)
!  ELSE
         CALL FILTH2(i3, imax, jmax, kmax, kmax_total,&
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n0, n1, cf2x, cf2y, cf2z, tmp7, tmp6, wrk3d)
!  ENDIF
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp6(ij,1,k) = tmp5(ij,1,k)*tmp6(ij,1,k)
         ENDDO
      ENDDO
      CALL PARTIAL_X(imode_fdm, imax, jmax, kmax, i1bc, dx, tmp6, tmp3, &
           i0, i0, wrk1d, wrk2d, wrk3d)

! component v
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp6(ij,1,k) = rho(ij,1,k)*v(ij,1,k)
         ENDDO
      ENDDO
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n0, cf0x, cf0y, cf0z, tmp6, tmp7, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp6(ij,1,k) = tmp4(ij,1,k)*tmp7(ij,1,k)
         ENDDO
      ENDDO
      CALL PARTIAL_Y(imode_fdm, imax, jmax, kmax, j1bc, dy, tmp6, tmp8, &
           i0, i0, wrk1d, wrk2d, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp2(ij,1,k) = tmp2(ij,1,k) + tmp8(ij,1,k)
         ENDDO
      ENDDO
!  IF ( iles_mpitype .EQ. 0 ) THEN
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n0, cf0x, cf0y, cf0z, tmp7, wrk3d, tmp6)
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n1, cf1x, cf1y, cf1z, wrk3d, tmp6, tmp7)
!  ELSE
         CALL FILTH2(i3, imax, jmax, kmax, kmax_total,&
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n0, n1, cf2x, cf2y, cf2z, tmp7, tmp6, wrk3d)
!  ENDIF
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp6(ij,1,k) = tmp5(ij,1,k)*tmp6(ij,1,k)
         ENDDO
      ENDDO
      CALL PARTIAL_Y(imode_fdm, imax, jmax, kmax, j1bc, dy, tmp6, tmp8, &
           i0, i0, wrk1d, wrk2d, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp3(ij,1,k) = tmp3(ij,1,k) + tmp8(ij,1,k)
         ENDDO
      ENDDO

! component w
      IF ( kmax_total .GT. 1 ) THEN
         DO k = 1,kmax
            DO ij = 1,imax*jmax
               tmp6(ij,1,k) = rho(ij,1,k)*w(ij,1,k)
            ENDDO
         ENDDO
         CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n0, cf0x, cf0y, cf0z, tmp6, tmp7, wrk3d)
         DO k = 1,kmax
            DO ij = 1,imax*jmax
               tmp6(ij,1,k) = tmp4(ij,1,k)*tmp7(ij,1,k)
            ENDDO
         ENDDO
         CALL PARTIAL_Z(imode_fdm, imax, jmax, kmax, k1bc, dz, tmp6, tmp8, &
              i0, i0, wrk1d, wrk2d, wrk3d)
         DO k = 1,kmax
            DO ij = 1,imax*jmax
               tmp2(ij,1,k) = tmp2(ij,1,k) + tmp8(ij,1,k)
            ENDDO
         ENDDO
!     IF ( iles_mpitype .EQ. 0 ) THEN
!        CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $           n0, cf0x, cf0y, cf0z, tmp7, wrk3d, tmp6)
!        CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $           n1, cf1x, cf1y, cf1z, wrk3d, tmp6, tmp7)
!     ELSE
            CALL FILTH2(i3, imax, jmax, kmax, kmax_total,&
                 iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
                 n0, n1, cf2x, cf2y, cf2z, tmp7, tmp6, wrk3d)
!     ENDIF
         DO k = 1,kmax
            DO ij = 1,imax*jmax
               tmp6(ij,1,k) = tmp5(ij,1,k)*tmp6(ij,1,k)
            ENDDO
         ENDDO
         CALL PARTIAL_Z(imode_fdm, imax, jmax, kmax, k1bc, dz, tmp6, tmp8, &
              i0, i0, wrk1d, wrk2d, wrk3d)
         DO k = 1,kmax
            DO ij = 1,imax*jmax
               tmp3(ij,1,k) = tmp3(ij,1,k) + tmp8(ij,1,k)
            ENDDO
         ENDDO
      ENDIF

#ifdef _DEBUG
         CALL IO_WRITE_ASCII_FIELD('u1.dat', imax, jmax, kmax, &
              tmp0)
         CALL IO_WRITE_ASCII_FIELD('u2.dat', imax, jmax, kmax, &
              tmp1)
         CALL IO_WRITE_ASCII_FIELD('u3.dat', imax, jmax, kmax, &
              tmp2)
         CALL IO_WRITE_ASCII_FIELD('u4.dat', imax, jmax, kmax, &
              tmp3)
#endif

! ##############################
! # tmp2 is the numerator, L   #
! # tmp3 is the denominator, H #
! ##############################

! term with div( wtb(u) ) in L
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n1, cf1x, cf1y, cf1z, p, tmp4, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp2(ij,1,k) = tmp2(ij,1,k)*tmp4(ij,1,k)
         ENDDO
      ENDDO

! term with div( wtb(wtb(b)) ) in H
!  IF ( iles_mpitype .EQ. 0 ) THEN
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n0, cf0x, cf0y, cf0z, tmp4, wrk3d, tmp6)
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n1, cf1x, cf1y, cf1z, wrk3d, tmp5, tmp6)
!  ELSE
         CALL FILTH2(i3, imax, jmax, kmax, kmax_total,&
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n0, n1, cf2x, cf2y, cf2z, tmp4, tmp5, wrk3d)
!  ENDIF
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp3(ij,1,k) =-tmp3(ij,1,k)*tmp5(ij,1,k)
         ENDDO
      ENDDO

! term in H
!  IF ( iles_mpitype .EQ. 0 ) THEN
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n0, cf0x, cf0y, cf0z, tmp2, wrk3d, tmp6)
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n1, cf1x, cf1y, cf1z, wrk3d, tmp4, tmp6)
!  ELSE
         CALL FILTH2(i3, imax, jmax, kmax, kmax_total,&
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n0, n1, cf2x, cf2y, cf2z, tmp2, tmp4, wrk3d)
!  ENDIF
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp3(ij,1,k) = tmp3(ij,1,k) + tmp4(ij,1,k)
         ENDDO
      ENDDO

! terms with div( u ) in L
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp4(ij,1,k) = p(ij,1,k)*tmp0(ij,1,k)
         ENDDO
      ENDDO
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n1, cf1x, cf1y, cf1z, tmp4, tmp5, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp2(ij,1,k) = tmp5(ij,1,k) - tmp2(ij,1,k)
         ENDDO
      ENDDO

! terms with div( u ) in H
!  IF ( iles_mpitype .EQ. 0 ) THEN
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n0, cf0x, cf0y, cf0z, tmp4, wrk3d, tmp6)
!     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
! $        n1, cf1x, cf1y, cf1z, wrk3d, tmp5, tmp6)
!  ELSE
         CALL FILTH2(i3, imax, jmax, kmax, kmax_total,&
              iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
              n0, n1, cf2x, cf2y, cf2z, tmp4, tmp5, wrk3d)
!  ENDIF
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp3(ij,1,k) = tmp3(ij,1,k) - tmp5(ij,1,k)
         ENDDO
      ENDDO

! terms with div( baru ) in H
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n0, cf0x, cf0y, cf0z, p, tmp5, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp5(ij,1,k) = tmp5(ij,1,k)*tmp1(ij,1,k)
         ENDDO
      ENDDO
      CALL FILTH(i3, imax, jmax, kmax, kmax_total, &
           iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
           n1, cf1x, cf1y, cf1z, tmp5, tmp4, wrk3d)
      DO k = 1,kmax
         DO ij = 1,imax*jmax
            tmp3(ij,1,k) = tmp3(ij,1,k) + tmp4(ij,1,k)
         ENDDO
      ENDDO

! ####################################################
! # Calculate spatial average of dynamic coefficient #
! # Clip it to positive values for stability         #        
! # Stored in wrk1d(1,1) or wrk2d(1,1)               #
! ####################################################
      IF ( imode_sim .EQ. DNS_MODE_TEMPORAL ) THEN
         DO j = 1,jmax
            wrk1d(j,1) = AVG_IK(imax, jmax, kmax, j, tmp2, &
                 dx, dz, area)
            wrk1d(j,2) = AVG_IK(imax, jmax, kmax, j, tmp3, &
                 dx, dz, area)
         ENDDO
         dummax = MAXVAL(wrk1d(1:jmax,2))
         dummax = dummax*C_1EM6_R
         DO j = 1,jmax
            wrk1d(j,1) = MAX(C_0_R,wrk1d(j,1))/&
                 MAX(wrk1d(j,2),dummax)
         ENDDO
      ELSE IF ( imode_sim .EQ. DNS_MODE_SPATIAL ) THEN
         CALL SUM_K_V(imax*jmax, kmax, tmp2, wrk2d(1,1), wrk2d(1,3))
         CALL SUM_K_V(imax*jmax, kmax, tmp3, wrk2d(1,2), wrk2d(1,3))
!#ifdef _DEBUG
         offset = (n0+n0+n1+n1)/2
         DO j = 1,jmax
            DO i = 1,offset
               ij = (j-1)*imax + i
               wrk2d(ij,1) = C_0_R
               wrk2d(ij,2) = C_0_R
            ENDDO
         ENDDO
         CALL IO_WRITE_ASCII_FIELD('num.dat', imax, jmax, i1, &
              wrk2d(1,1))
         CALL IO_WRITE_ASCII_FIELD('den.dat', imax, jmax, i1, &
              wrk2d(1,2))
!#endif
         dummax = MAXVAL(wrk2d(1:imax*jmax,2))
         dummax = dummax*C_1EM3_R
         DO ij = 1,imax*jmax
            wrk2d(ij,1) = MAX(C_0_R,wrk2d(ij,1))/&
                 MAX(wrk2d(ij,2),dummax)
         ENDDO
! incompatibility filter-BCs with dilatation
         offset = (n0+n0+n1+n1)/2
         DO j = 1,jmax
            DO i = 1,offset
               ij = (j-1)*imax + i
               wrk2d(ij,1) = C_0_R
            ENDDO
            DO i = imax-offset,imax
               ij = (j-1)*imax + i
               wrk2d(ij,1) = C_0_R
            ENDDO
         ENDDO
         DO j = 1,offset
            DO i = 1,imax
               ij = (j-1)*imax + i
               wrk2d(ij,1) = C_0_R
            ENDDO
         ENDDO
         DO j = jmax-offset,jmax
            DO i = 1,imax
               ij = (j-1)*imax + i
               wrk2d(ij,1) = C_0_R
            ENDDO
         ENDDO
!#ifdef _DEBUG
         CALL IO_WRITE_ASCII_FIELD('Cpdil.dat', imax, jmax, i1, &
              wrk2d(1,1))
!#endif
      ENDIF

      CALL SGS_RECTN_PDIL(n0, statflg, dx, dy, dz, rho, u, v, w, p,&
           h4, mean1d_les, tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6,&
           tmp7, wrk1d, wrk2d, wrk3d, cf0x, cf0y, cf0z)

#ifdef TRACE_ON
      CALL IO_WRITE_ASCII(tfile, 'LEAVING SGS_DYN_PDIL' )
#endif

      RETURN
      END
