SUBROUTINE SGS_FIELDS(iflg_loc, n0, dx, dy, dz, cf0x, cf0y, cf0z, rho, u, u_sg, txc, wrk2d, wrk3d)
        
#include "types.h"
#include "dns_const.h"
#include "les_const.h"

  USE DNS_GLOBAL
  USE LES_GLOBAL

  IMPLICIT NONE

#include "integers.h"

  TINTEGER iflg_loc, n0

  TREAL dx(imax)
  TREAL dy(jmax)
  TREAL dz(kmax_total)

  TREAL rho(imax,jmax,kmax)
  TREAL u(imax,jmax,kmax)
  TREAL u_sg(imax,jmax,kmax)

  TREAL cf0x(*), cf0y(*), cf0z(*)

  TREAL txc(imax,jmax,kmax)
  TREAL wrk2d(*), wrk3d(*)

  TINTEGER ij, k

  DO k = 1,kmax
     DO ij = 1,imax*jmax
        u_sg(ij,1,k) = u(ij,1,k)
     ENDDO
  ENDDO

! checking rms mode
  IF ( iflg_loc .EQ. LES_REGU_SMGDYNRMS ) THEN 
     IF ( imode_sim .EQ. DNS_MODE_TEMPORAL ) THEN
        CALL FAVFLUCT2D(imax, jmax, kmax, dx, dz, area, u_sg, rho, wrk3d)

     ELSEIF ( imode_sim .EQ. DNS_MODE_SPATIAL ) THEN
        CALL FAVFLUCT1D(imax, jmax, kmax, u_sg, rho, wrk2d)

     ENDIF
  ENDIF

  RETURN
END SUBROUTINE SGS_FIELDS
