SUBROUTINE KT_SPA(nvar, ntimes, kmax, kmax_total, nstatlin, &
     statlin_i, statlin_j, t_dat, l_dat, spct, wrk, wrk1d )

!
! FFTW NOT YET CHECKED
!
#include "types.h"


#ifdef PARALLEL
  USE DNS_MPI
#endif

  IMPLICIT NONE

#ifdef PARALLEL
#include "mpif.h"
#endif
#ifdef USE_FFTW
#include "fftw3.f"
#endif

  TINTEGER nvar, ntimes, kmax, kmax_total, nstatlin

  TREAL t_dat(2,ntimes)
  TREAL l_dat(ntimes,nstatlin,nvar,kmax)

  TINTEGER statlin_i(nstatlin), statlin_j(nstatlin)

  TREAL wrk(2*ntimes+15)
  TREAL spct(ntimes/2,nstatlin,nvar)
  TREAL wrk1d(ntimes,4)

  TINTEGER n, i, j, k, ivar, it
  TREAL delta_t, freq
! TREAL sum
  CHARACTER*32 filename
  INTEGER(8) fft_plan

#ifdef PARALLEL
  INTEGER len
!  TREAL sum2
#endif

! ################
! # Initializing #
! ################

! -----------------------------------------------------------------------
! FFTW
! -----------------------------------------------------------------------
#ifdef USE_FFTW
  CALL dfftw_plan_dft_r2c_1d(fft_plan, ntimes, wrk, wrk, FFTW_ESTIMATE)
! -----------------------------------------------------------------------
! old fft
! -----------------------------------------------------------------------
#else
  CALL RFFTI ( ntimes, wrk )
#endif

  DO it = 1,ntimes/2*nvar*nstatlin
     spct(it,1,1) = C_0_R
  ENDDO

  DO it = 1,ntimes
     wrk1d(it,1) = t_dat(2,it)
  ENDDO

! l_dat has to enter with the mean removed
! ###################
! # Remove the mean #
! ###################
!
!  DO i = 1,nvar
!     DO n = 1,nstatlin
!        
!        sum = C_0_R
!        DO k = 1,kmax
!           DO it = 1,ntimes
!              sum = sum + l_dat(it,n,i,k)
!           ENDDO
!        ENDDO
!        sum = sum/M_REAL(ntimes)
!#ifdef PARALLEL
!        sum2 = sum/M_REAL(kmax_total)
!        CALL MPI_ALLREDUCE(sum2, sum, 1, MPI_REAL8, MPI_SUM, 
! $           MPI_COMM_WORLD, ims_err)
!#else 
!        sum = sum/M_REAL(kmax_total)
!#endif
!        DO k = 1,kmax
!           DO it = 1,ntimes
!              l_dat(it,n,i,k) = l_dat(it,n,i,k) - sum
!           ENDDO
!        ENDDO
!
!     ENDDO
!  ENDDO

! #########################
! # Obtaining the spectra #
! #########################

  DO k = 1,kmax
     DO ivar = 1, 2
        DO n = 1,nstatlin
           CALL MK_CST_DT(ntimes, l_dat(1,n,ivar,k), wrk1d(1,1), delta_t, wrk1d(1,3))
           CALL KZ1D_SPA ( ntimes, wrk1d(1,3), fft_plan, wrk, wrk1d(1,2), wrk1d(1,4) )
           DO it = 1,ntimes/2
              spct(it,n,ivar) = spct(it,n,ivar) + wrk1d(it,2)
           ENDDO
        ENDDO
     ENDDO
  ENDDO

  IF ( kmax_total .GT. 1 ) THEN
     DO k = 1,kmax
        DO n = 1,nstatlin
           CALL MK_CST_DT(ntimes, l_dat(1,n,3,k), wrk1d(1,1), delta_t, wrk1d(1,3))
           CALL KZ1D_SPA ( ntimes, wrk1d(1,3), fft_plan, wrk, wrk1d(1,2), wrk1d(1,4) )
           DO it = 1,ntimes/2
              spct(it,n,3) = spct(it,n,3) + wrk1d(it,2)
           ENDDO
        ENDDO
     ENDDO
  ENDIF

  DO k = 1,kmax
     DO ivar = 4, nvar
        DO n = 1,nstatlin
           CALL MK_CST_DT(ntimes, l_dat(1,n,ivar,k), wrk1d(1,1), delta_t, wrk1d(1,3))
           CALL KZ1D_SPA ( ntimes, wrk1d(1,3), fft_plan, wrk, wrk1d(1,2), wrk1d(1,4) )
           DO it = 1,ntimes/2
              spct(it,n,ivar) = spct(it,n,ivar) + wrk1d(it,2)
           ENDDO
        ENDDO
     ENDDO
  ENDDO

! Average in k

#ifdef PARALLEL
  len = ntimes/2*nstatlin*nvar
  CALL MPI_ALLREDUCE(spct, l_dat, len, MPI_REAL8, MPI_SUM, &
       MPI_COMM_WORLD, ims_err)
  DO it = 1,ntimes/2*nvar*nstatlin
     spct(it,1,1) = l_dat(it,1,1,1)
  ENDDO
#endif

  DO it = 1,ntimes/2*nvar*nstatlin
     spct(it,1,1) = spct(it,1,1)/M_REAL(kmax_total*ntimes)
  ENDDO

! ################################
! # Normalized so that N*Rij = sum_1^N Eij,
! # where Eij is the energy itself times N.
! # For DFT Parseval`s equality is Rij=sum_1^N Eij,
! # if Eij were the energy itself. 
! # This is done to collapse all the curves for
! # different number of points.
! ##########################################

! ###############
! # Tkstat file #
! ###############

#ifdef PARALLEL
  IF ( ims_pro .EQ. 0 ) THEN
#endif

     filename = 'tsp                                     '
     it = INT(t_dat(1,ntimes))
     CALL CONCATI(filename, it)

     OPEN(unit=23,file=filename)
     WRITE(23, *) 'RTIME = ', t_dat(2,ntimes)
     WRITE(23, *) 'I J ft Eu(ft) Ev(ft) Ew(ft) E(ft) P(ft) R(ft) S(ft)'

     DO n = 1,nstatlin
        i = statlin_i(n)
        j = statlin_j(n)
        DO it = 2, ntimes/2
           freq = M_REAL(it-1)/(t_dat(2,ntimes)-t_dat(2,1))  
           WRITE(23,1020) i, j, freq, spct(it,n,1), spct(it,n,2), &
                spct(it,n,3), &
                C_05_R*(spct(it,n,1)+spct(it,n,2)+spct(it,n,3)),&
                spct(it,n,4), spct(it,n,5), spct(it,n,6)
        ENDDO
     ENDDO

     CLOSE(23)

#ifdef PARALLEL
  ENDIF
#endif

! ###################################################################
#ifdef USE_FFTW
  CALL dfftw_destroy_plan(fft_plan)
#endif

  RETURN

1020 FORMAT(I3,1X,I3,8(1X,E12.5E3))

END SUBROUTINE KT_SPA


