SUBROUTINE KZ1D_SPA ( nx, udt, fft_plan, fft_data, spectrum, wrk1d )
 
! FFTW not yet checked

  IMPLICIT NONE
  
#include "types.h"
  
  TINTEGER nx
  TREAL udt(nx)
  TREAL fft_data(2*nx+15)
  TREAL spectrum(nx/2), wrk1d(*)
  
  TINTEGER i
#ifdef USE_FFTW
#else
  TINTEGER icomplex
#endif
  INTEGER(8) fft_plan

! ###################    
! # Perform 1-D FFT #
! ###################    
  
! -----------------------------------------------------------------------
! FFTW
! -----------------------------------------------------------------------
#ifdef USE_FFTW
! Perform 1D fft
     CALL dfftw_execute_dft_r2c(fft_plan, udt, wrk1d)
! power spectral density
     spectrum(1) = spectrum(1) + (wrk1d(1)**2)
     DO i = 2, nx/2
        spectrum(i) = spectrum(i) + wrk1d(2*i-1)**2 + wrk1d(2*i)**2
     ENDDO

! -----------------------------------------------------------------------
! old fft
! -----------------------------------------------------------------------
#else
  CALL RFFTF ( nx, udt, fft_data )

! ############################################
! # Obtain DFT                               #
! # We should divide by the number of points #
! # but it is done later                     #
! ############################################
  
! ###################
! # Obtain spectrum #
! ###################
  
  spectrum(1) = udt(1)**2/C_2_R
  
  DO i = 2, nx/2
     icomplex = 2*i-1
     spectrum(i) = udt(icomplex-1)*udt(icomplex-1) + udt(icomplex)*udt(icomplex)
  ENDDO
#endif
  
  RETURN
END SUBROUTINE KZ1D_SPA

