














		   



			   
               	           






!########################################################################
!# Tool/Library DNS
!#
!########################################################################
!# HISTORY
!#
!# 2007/10/08 - J.P. Mellado
!#              Created
!#
!########################################################################
!# DESCRIPTION
!#
!# Calculate liquid content from p, T and water content.
!#
!########################################################################
!# ARGUMENTS 
!#
!########################################################################
SUBROUTINE THERMO_AIRWATER_PT(nx, ny, nz, z1, p, T)

  USE THERMO_GLOBAL, ONLY : GRATIO, MRATIO, WGHT_INV, THERMO_AI, dsmooth

  IMPLICIT NONE

  INTEGER(4) nx, ny, nz
  REAL(8) z1(nx*ny*nz,*), T(*), p(*)

! -------------------------------------------------------------------
  INTEGER(4) ij
  REAL(8) qsat, dqldqt, dsmooth_loc

! ###################################################################
  CALL THERMO_POLYNOMIAL_PSAT(nx, ny, nz, T, z1(1,2))
  DO ij = 1,nx*ny*nz
! this is really the vapor content
     qsat = 1.0d0/(MRATIO*p(ij)/z1(ij,2)-1.0d0)*WGHT_INV(2)/WGHT_INV(1)*(1-z1(ij,1))
     IF ( qsat .GE. z1(ij,1) ) THEN
        z1(ij,2) = 0.0d0
     ELSE
        z1(ij,2) = z1(ij,1) - qsat
     ENDIF
     IF ( dsmooth .GT. 0.0d0 ) THEN
        qsat = qsat/(1-z1(ij,1))
        dqldqt = 1.0d0 + qsat
! this is the real qsat
        qsat = qsat/(1.0d0+qsat)
        dsmooth_loc = dsmooth*qsat
        z1(ij,2) = dsmooth_loc*dqldqt&
             *LOG(EXP((z1(ij,1)-qsat)/dsmooth_loc)+1.0d0)
     ENDIF
  ENDDO

  RETURN
END SUBROUTINE THERMO_AIRWATER_PT
