














		   



			   
               	           












  
!########################################################################
!# Tool/Library
!#
!########################################################################
!# HISTORY
!#
!########################################################################
!# DESCRIPTION
!#
!########################################################################
!# ARGUMENTS 
!#
!########################################################################
SUBROUTINE THERMO_READ_CHEMKIN(name)

  USE THERMO_GLOBAL
  USE DNS_GLOBAL, ONLY : efile, lfile

  IMPLICIT NONE

INTEGER(4) i0, i1, i2, i3, i4, i5, i6, i7 ,i8, i9
  PARAMETER(i0=0)
  PARAMETER(i1=1)
  PARAMETER(i2=2)
  PARAMETER(i3=3)
  PARAMETER(i4=4)
  PARAMETER(i5=5)
  PARAMETER(i6=6)
  PARAMETER(i7=7)
  PARAMETER(i8=8)
  PARAMETER(i9=9)
  INTEGER(4) i10, i11, i12, i13, i14, i15, i16, i17 ,i18, i19
  PARAMETER(i10=10)
  PARAMETER(i11=11)
  PARAMETER(i12=12)
  PARAMETER(i13=13)
  PARAMETER(i14=14)
  PARAMETER(i15=15)
  PARAMETER(i16=16)
  PARAMETER(i17=17)
  PARAMETER(i18=18)
  PARAMETER(i19=19)
  INTEGER(4) i20, i21, i22, i23, i24, i25, i26, i27 ,i28, i29
  PARAMETER(i20=20)
  PARAMETER(i21=21)
  PARAMETER(i22=22)
  PARAMETER(i23=23)
  PARAMETER(i24=24)
  PARAMETER(i25=25)
  PARAMETER(i26=26)
  PARAMETER(i27=27)
  PARAMETER(i28=28)
  PARAMETER(i29=29)
  INTEGER(4) i30, i31, i32, i33, i34, i35, i36, i37 ,i38, i39
  PARAMETER(i30=30)
  PARAMETER(i31=31)
  PARAMETER(i32=32)
  PARAMETER(i33=33)
  PARAMETER(i34=34)
  PARAMETER(i35=35)
  PARAMETER(i36=36)
  PARAMETER(i37=37)
  PARAMETER(i38=38)
  PARAMETER(i39=39)
  INTEGER(4) i50, i51, i52, i53, i54, i55, i56, i57 ,i58, i59
  PARAMETER(i50=50)
  PARAMETER(i51=51)
  PARAMETER(i52=52)
  PARAMETER(i53=53)
  PARAMETER(i54=54)
  PARAMETER(i55=55)
  PARAMETER(i56=56)
  PARAMETER(i57=57)
  PARAMETER(i58=58)
  PARAMETER(i59=59)
  INTEGER(4) i150
  PARAMETER(i150=150)

  CHARACTER*(*) name

! -----------------------------------------------------------------------
  REAL(8) T1, T2, T3
  INTEGER(4) i, il, is
  LOGICAL frun
  CHARACTER*15 token
  CHARACTER*225 wline
  CHARACTER*80 line, line1, line2, line3
  INTEGER(4) THERMO_FLAG(MAX_NSP)

! #######################################################################
! Initialize thermodynamic data structure
  DO is=1, NSP
     THERMO_FLAG(is) = 0
  ENDDO

! Read Thermodynamic file
  OPEN(i23,file=name,status='old')

  REWIND(i23)

! Read Header
  READ(i23,*) line
  CALL OUTPUT(lfile, line)

  IF ( TRIM(ADJUSTL(line)) .NE. 'THERMO' ) THEN
     CALL OUTPUT(efile, 'Error: Thermodynamic file format error')
     CALL DNS_STOP(91)
  ENDIF

! Read Temperature ranges
  READ(i23, *) T1, T2, T3
  WRITE(wline,*) T1, T2, T3
  CALL OUTPUT(lfile, wline(1:80))

! Remove comments
  frun = .TRUE.
  DO WHILE( frun )
     READ(i23,'(A80)',END=50) line
     IF ( line(1:1) .NE. '!' ) frun = .FALSE.
  ENDDO

  frun = .TRUE. 
  DO WHILE ( frun )
!    Check for end of file
     READ(line,'(A15)',END=50) token
     IF ( TRIM(ADJUSTL(token)) .EQ. 'END' ) THEN
        frun = .FALSE.
        GOTO 50
     ENDIF

!    Read all relevant information
     READ(i23,'(A80)',END=50) line1
     READ(i23,'(A80)',END=50) line2
     READ(i23,'(A80)',END=50) line3

!    Process lines
     DO is = 1,NSP
        IF ( TRIM(ADJUSTL(token)) .EQ. THERMO_SPNAME(is) ) THEN
           CALL OUTPUT(lfile, line)
           CALL OUTPUT(lfile, line1)
           CALL OUTPUT(lfile, line2)
           CALL OUTPUT(lfile, line3)

!          Required species found, process information
!          Get limit temperatures
           DO i=1, 225
              wline(i:i) = ' '
           ENDDO
           wline=line(46:75)
           READ(wline,*) (THERMO_TLIM(i,is),i=1,3)

!          Concatenate lines so read is simpler
           wline=line1(1:75)//line2(1:75)//line3(1:75)

           DO i=1,14
              il = (i-1)*15+1
              READ(wline(il:il+14),*) THERMO_AI(i,1,is)
           ENDDO

           THERMO_FLAG(is) = 1
        ENDIF
     ENDDO

!    Read next line
     READ(i23, '(A80)',END=50) line

  ENDDO

50 CLOSE(i23)

  DO is = 1,NSP
     IF ( THERMO_FLAG(is) .EQ. 0 ) THEN
        CALL OUTPUT(efile, 'Error: Not all thermodynamic data contained in thermo file')
        CALL DNS_STOP(92)
     ENDIF
  ENDDO

  RETURN
END SUBROUTINE THERMO_READ_CHEMKIN
