














		   



			   
               	           





  
!########################################################################
!# Tool/Library
!#
!########################################################################
!# HISTORY
!#
!# 2007/01/01 - J.P. Mellado
!#              Created
!#
!########################################################################
!# DESCRIPTION
!#
!# Calculate the nondimensional dynamic viscosity \mu=\mu(T) depending
!# on the given flag itransport:
!#
!# 0 None
!# 1 Powerlaw
!# 2 Sutherland
!# 
!########################################################################
!# ARGUMENTS 
!#
!########################################################################
SUBROUTINE THERMO_VISCOSITY(nx,ny,nz, T, mu)
  
  USE DNS_GLOBAL, ONLY : itransport

  IMPLICIT NONE
  
  INTEGER(4) nx,ny,nz
  REAL(8), DIMENSION(nx*ny*nz) :: T, mu

! -----------------------------------------------------------------------
  REAL(8) dummy

! #######################################################################
  IF      ( itransport .EQ. 2 ) THEN ! Sutherland. NOT YET IMPLEMENTED !
     mu = 1.0d0  

  ELSE IF ( itransport .EQ. 1 ) THEN ! Powerlaw
     dummy = 7.0d0/10.0d0
     mu = T**dummy

  ELSE
     mu = 1.0d0 
     
  ENDIF
          
  RETURN
END SUBROUTINE THERMO_VISCOSITY
