PROGRAM FLAMELETS

  USE DNS_GLOBAL

  IMPLICIT NONE

#include "types.h"
#include "dns_const.h"
#include "dns_error.h"

  TREAL Z(:)
  ALLOCATABLE Z
  TREAL Y(:,:)
  ALLOCATABLE Y
  TREAL Yh(:,:)
  ALLOCATABLE Yh
  TREAL T(:)
  ALLOCATABLE T
  TREAL Th(:)
  ALLOCATABLE Th
  TREAL rho(:)
  ALLOCATABLE rho
  TREAL dZ(:)
  ALLOCATABLE dZ
  TREAL wrk1d(:)
  ALLOCATABLE wrk1d
  TREAL wrk2d(:)
  ALLOCATABLE wrk2d
  TREAL tmp(:)
  ALLOCATABLE tmp

  TINTEGER nmax, n, is, ierr
  TINTEGER i0, i1, i23
  TREAL chi, eps

  i0 = 0
  i1 = 1
  i23=23

  CALL DNS_INITIALIZE

  CALL DNS_READ_GLOBAL('dns.ini')

! Local data
  CALL SCANINIINT(lfile, 'dns.ini', 'Flamelets', 'Points',&
       '128', nmax)
  CALL SCANINIREAL(lfile, 'dns.ini', 'Flamelets', 'Chi',&
       '1.0', chi)
  CALL SCANINIINT(lfile, 'dns.ini', 'Flamelets', 'Error',&
       '1.0', ierr)
  eps = EXP(-M_REAL(ierr)*LOG(C_10_R))

  imax = nmax
  jmax = 1
  kmax = 1

  ALLOCATE(Z(nmax))
  ALLOCATE(Y(nmax,NSP-1))
  ALLOCATE(Yh(nmax,NSP-1))
  ALLOCATE(T(nmax))
  ALLOCATE(Th(nmax))
  ALLOCATE(rho(nmax))
  ALLOCATE(dZ(nmax))
  ALLOCATE(wrk1d(MX1D*nmax))
  ALLOCATE(wrk2d(MX2D*nmax*nmax))
  ALLOCATE(tmp(3*nmax))

! Discretize the mixture fraction
  DO n = 1,nmax
     Z(n) = M_REAL(n-1)/M_REAL(nmax-1)
  ENDDO
  scalez = C_1_R
! space in dZ needs to be reviewed
!  CALL FDM_INITIALIZE(i0, imode_fdm, nmax, i1, scalez, Z, dZ, wrk1d)

  CALL FLAME_INIT(nmax, Z, Y, T, rho)

  OPEN(i23,file='flame_init.dat')
  DO n = 1,nmax
     WRITE(i23,'(10f12.8)') Z(n),&
          (Y(n,is),is=1,NSP-1),T(n),rho(n)
  ENDDO
  CLOSE(i23)

  CALL FLAME_TIME(nmax, Z, dZ, Y, Yh, T, Th, rho, chi, eps,&
       wrk1d, wrk2d, tmp)

  CALL DNS_END(0)

  STOP
END PROGRAM FLAMELETS
