SUBROUTINE DEC_SERIES(mmax, imax, jmax, kmax, kmax_total, &
     iunifx, iunify, iunifz, i1bc, j1bc, k1bc, n0, nmax, &
     area, dx, dy, dz, cf0x, cf0y, cf0z, c0, z2sg,&
     z1_b, z1_a, txc1, txc2, txc3, wrk1d, wrk3d)

  IMPLICIT NONE

#include "types.h"
#include "integers.h"

  TINTEGER mmax
  TINTEGER imax, jmax, kmax, kmax_total
  TINTEGER iunifx, iunify, iunifz
  TINTEGER i1bc, j1bc, k1bc
  TINTEGER n0, nmax

  TREAL area
  TREAL dx(imax)
  TREAL dy(jmax)
  TREAL dz(kmax_total)

  TREAL txc1(imax,jmax,kmax)
  TREAL txc2(imax,jmax,kmax)
  TREAL txc3(imax,jmax,kmax)
  TREAL z1_a(imax,jmax,kmax)
  TREAL z1_b(imax,jmax,kmax)

  TREAL wrk1d(jmax,*)
  TREAL wrk3d(imax,jmax,kmax)
  TREAL cf0x(*), cf0y(*), cf0z(*)
  TREAL c0(*), z2sg(*)

  TINTEGER ij, k, j, i, n
  TREAL AVG_IK, disc

#define A0(j)       wrk1d(j,1)
#define A1(j)       wrk1d(j,2)
#define A2(j)       wrk1d(j,3)

  DO j = 1,jmax
     A0(j) =-z2sg(j)
  ENDDO

  ! -------------------------------------------------------------------
  !                                               Compute Za and Zb
  ! -------------------------------------------------------------------
  ! here, z1_b should be bar(Z) which is the case i=0
  z1_a = C_0_R

  DO n = 1,nmax-1

     DO k = 1,kmax
        DO ij = 1,imax*jmax
           z1_a(ij,1,k) = z1_a(ij,1,k) + z1_b(ij,1,k)
        ENDDO
     ENDDO
     !     CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
     ! $        iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
     ! $        n0, cf0x, cf0y, cf0z, z1_b, txc1, wrk3d)
     CALL DEC_FILTER(mmax, imax, jmax, kmax, kmax_total, &
          iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
          n0, cf0x, cf0y, cf0z, z1_b, txc1, txc3, wrk3d)
     DO k = 1,kmax
        DO ij = 1,imax*jmax
           z1_b(ij,1,k) = z1_b(ij,1,k) - txc1(ij,1,k)
        ENDDO
     ENDDO

  ENDDO

  ! -------------------------------------------------------------------
  !                                             Compute coefficient
  ! -------------------------------------------------------------------
  ! coefficient A0
  DO k = 1,kmax
     DO ij = 1,imax*jmax
        txc1(ij,1,k) = z1_a(ij,1,k)*z1_a(ij,1,k)
     ENDDO
  ENDDO
  !  CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
  ! $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
  ! $     n0, cf0x, cf0y, cf0z, txc1, txc2, wrk3d)
  CALL DEC_FILTER(mmax, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n0, cf0x, cf0y, cf0z, txc1, txc2, txc3, wrk3d)
  DO j = 1,jmax
     A0(j) = A0(j) +&
          AVG_IK(imax, jmax, kmax, j, txc2, dx, dz, area)
  ENDDO
  !
  !  CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
  ! $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
  ! $     n0, cf0x, cf0y, cf0z, z1_a, txc1, wrk3d)
  CALL DEC_FILTER(mmax, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n0, cf0x, cf0y, cf0z, z1_a, txc1, txc3, wrk3d)
  DO k = 1,kmax
     DO ij = 1,imax*jmax
        txc2(ij,1,k) = txc1(ij,1,k)*txc1(ij,1,k)
     ENDDO
  ENDDO
  DO j = 1,jmax
     A0(j) = A0(j) -&
          AVG_IK(imax, jmax, kmax, j, txc2, dx, dz, area)
  ENDDO

  ! coefficient A1
  !  CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
  ! $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
  ! $     n0, cf0x, cf0y, cf0z, z1_b, txc2, wrk3d)
  CALL DEC_FILTER(mmax, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n0, cf0x, cf0y, cf0z, z1_b, txc2, txc3, wrk3d)
  DO k = 1,kmax
     DO ij = 1,imax*jmax
        txc1(ij,1,k) = txc1(ij,1,k)*txc2(ij,1,k)
     ENDDO
  ENDDO
  DO j = 1,jmax
     A1(j) = &
          -AVG_IK(imax, jmax, kmax, j, txc1, dx, dz, area)
  ENDDO
  !
  DO k = 1,kmax
     DO ij = 1,imax*jmax
        txc1(ij,1,k) = z1_b(ij,1,k)*z1_a(ij,1,k)
     ENDDO
  ENDDO
  !  CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
  ! $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
  ! $     n0, cf0x, cf0y, cf0z, txc1, txc2, wrk3d)
  CALL DEC_FILTER(mmax, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n0, cf0x, cf0y, cf0z, txc1, txc2, txc3, wrk3d)
  DO j = 1,jmax
     A1(j) = C_2_R*(A1(j)+&
          AVG_IK(imax, jmax, kmax, j, txc2, dx, dz, area))
  ENDDO

  ! coefficient A2
  DO k = 1,kmax
     DO ij = 1,imax*jmax
        txc1(ij,1,k) = z1_b(ij,1,k)*z1_b(ij,1,k)
     ENDDO
  ENDDO
  !  CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
  ! $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
  ! $     n0, cf0x, cf0y, cf0z, txc1, txc2, wrk3d)
  CALL DEC_FILTER(mmax, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n0, cf0x, cf0y, cf0z, txc1, txc2, txc3, wrk3d)
  DO j = 1,jmax
     A2(j) = &
          AVG_IK(imax, jmax, kmax, j, txc2, dx, dz, area)
  ENDDO
  !
  !  CALL FILTH(i3, imax, jmax, kmax, kmax_total, 
  ! $     iunifx, iunify, iunifz, i1bc, j1bc, k1bc,
  ! $     n0, cf0x, cf0y, cf0z, z1_b, txc1, wrk3d)
  CALL DEC_FILTER(mmax, imax, jmax, kmax, kmax_total, &
       iunifx, iunify, iunifz, i1bc, j1bc, k1bc,&
       n0, cf0x, cf0y, cf0z, z1_b, txc1, txc3, wrk3d)
  DO k = 1,kmax
     DO ij = 1,imax*jmax
        txc1(ij,1,k) = txc1(ij,1,k)*txc1(ij,1,k)
     ENDDO
  ENDDO
  DO j = 1,jmax
     A2(j) = A2(j) -&
          AVG_IK(imax, jmax, kmax, j, txc1, dx, dz, area)
  ENDDO

  ! coefficient
  DO j = 1,jmax
     IF ( A0(j) .LT. C_0_R .AND. A2(j) .GT. C_0_R ) THEN
        disc = A1(j)*A1(j)-C_4_R*A0(j)*A2(j)
        C0(j) = C_05_R*(-A1(j)+SQRT(disc))/&
             A2(j)
     ELSE
        C0(j) = C_0_R
     ENDIF
  ENDDO

  ! -------------------------------------------------------------------
  !                                                Obtaining fields
  ! -------------------------------------------------------------------
  DO j = 1,jmax
     DO k = 1,kmax
        DO i = 1,imax
           txc1(i,j,k) = z1_a(i,j,k) + C0(j)*z1_b(i,j,k)
        ENDDO
     ENDDO
  ENDDO

  ! ADM field
  DO k = 1,kmax
     DO ij = 1,imax*jmax
        txc2(ij,1,k) = z1_a(ij,1,k) + z1_b(ij,1,k)
     ENDDO
  ENDDO

#undef A0
#undef A1
#undef A2

  RETURN
END SUBROUTINE DEC_SERIES
