      SUBROUTINE FLAMELET_GRID(n, zst, rg, z)
      
      IMPLICIT NONE

#include "types.h"

      TREAL zst, rg
      TINTEGER n, i
      TREAL z(0:n+1)
      TREAL r1, r2, dz, dzi, mu

      r1 = rg
      IF ( rg .EQ. C_1_R ) THEN
         r2 = C_1_R
         dz = C_1_R/M_REAL(n)
      ELSE
         dz = zst*(C_1_R-r1)/(C_1_R-r1**(n/2+3))
         dzi = dz*r1**(n/2+3)
         mu = (C_1_R-zst)/dzi
         r2 = C_1_R/r1
         DO i=1, 20
            r2 = EXP(C_2_R*LOG(C_1_R-mu*(C_1_R-r2))/M_REAL(n))
         ENDDO
      ENDIF

      z(0) = C_0_R
      DO i=1, n+1
         z(i) = z(i-1) + dz
         IF ( i .LT. n/2+3 ) THEN
            dz = dz*r1
         ELSE
            dz = dz*r2
         ENDIF
      ENDDO
! Fix ending
      DO i=0, n+1
         z(i) = z(i)/z(n+1)
!     PRINT *, i, z(i)
      ENDDO

!  stop

      RETURN
      END
