      SUBROUTINE FLAMELET_POST(name, NZ, z, x, lewis, xi)

      IMPLICIT NONE

#include "types.h"
#include "common.h"

      CHARACTER*(*) name
      TINTEGER NZ
      TREAL z(*)
      TREAL x(*)
      TREAL lewis(*)
      TREAL xi(*)
      TREAL kr(6), lnT
      TREAL b, delta, Xo2
      TINTEGER i, ik, is

#define k1    kr(1)
#define k5    kr(2)
#define k10   kr(3)
#define k11   kr(4)
#define KII   kr(5)
#define KIV   kr(6)

#define Y(i,is) x((is-1)*NZ+i)
#define T(i)    Y(i,NSP)

      b = YOX*WGHT(NSP)/(C_2_R*WGHT(2)*XIST)

      OPEN(UNIT=23, FILE=name, STATUS='unknown')

      DO i=1, NZ

!    Pass species to YMASS vector
         YMASS(NSP) = C_1_R
         DO is=1, NSP-1
            YMASS(is) = Y(i,is)
            YMASS(NSP) = YMASS(NSP)-YMASS(is)
         ENDDO
         
!    Compute mean molecular weight of mayor species
         WMEAN = C_0_R
         DO is=1, NSP
            WMEAN = WMEAN + YMASS(is)/WGHT(is)
         ENDDO
         WMEAN = C_1_R/(WMEAN*WREF)

         lnT = LOG(T(i))

         DO ik=1,NMECH
            kr(ik) = mech_pre(ik)*&
                 EXP(-mech_tac(ik)/T(i)&
                 +mech_beta(ik)*lnT)
         ENDDO

         Xo2 = Y(i,2)*WMEAN*WREF/WGHT(2)
         delta = k1*Xo2/(k11*lewis(1)*b)
         
         WRITE(23,122) z(i), T(i), delta
      ENDDO

      CLOSE(23)

 122  FORMAT(3(1X,E12.5E3))

      RETURN
      END
