SUBROUTINE ADD_SUBS( iop, itimeorigin, mean, meanorigin )
  
#include "types.h"

  USE DNS_GLOBAL

  IMPLICIT NONE

  TINTEGER iop, itimeorigin
  TREAL mean(nstatavg,jmax,inb_mean_spatial)
  TREAL meanorigin(nstatavg,jmax,inb_mean_spatial)

  TINTEGER  istattimeorgorigin, nstatavg_pointsorigin
  TREAL rtimeorigin, rstattimeorgorigin 
  TINTEGER nstat, n
  TINTEGER i54, i55
  CHARACTER*32 afile 

  i54 = 54
  i55 = 55

! ########################
! # Opening initial file #
! ########################

  afile='st                                '
  CALL CONCATI(afile, itimeorigin)
  OPEN(unit=i54,file=afile,&
       form='unformatted',status='unknown')
  iop = 0
  nstat = inb_mean_spatial
  CALL RD_STHD( i54, iop, istat_maj_ver, istat_min_ver, &
       itimeorigin, rtimeorigin, &
       istattimeorgorigin, rstattimeorgorigin, &
       nstatavg, jmax, nstat, &
       nstatavg_pointsorigin, statavg )
  CALL RD_REC( i54, iop, nstatavg, jmax, nstat, meanorigin )
  CLOSE(i54)

! ############################################
! # Substracting data from the previous file #
! ############################################

  IF (iop .EQ. 1) THEN
     IF ( istattimeorgorigin .NE. istattimeorg ) THEN
        CALL IO_WRITE_ASCII(efile,'ADD_SUBS: Not same time origin'//&
             'of files')
        CALL DNS_STOP(700)
     ENDIF
     DO n = 1,nstatavg*jmax*inb_mean_spatial
        meanorigin(n,1,1) = mean(n,1,1) - meanorigin(n,1,1)
     ENDDO
     nstatavg_pointsorigin = nstatavg_points - nstatavg_pointsorigin
     istattimeorgorigin = itimeorigin
     rstattimeorgorigin = rtimeorigin

! ######################################
! # Adding data from the previous file #
! ######################################

  ELSE IF (iop .EQ. 2) THEN
     IF ( istattimeorg .NE. itimeorigin ) THEN
        CALL IO_WRITE_ASCII(efile,'ADD_SUBS: Not consecutive times '//&
             'of files')
        CALL DNS_STOP(700)
     ENDIF
     DO n = 1,nstatavg*jmax*inb_mean_spatial
        meanorigin(n,1,1) = mean(n,1,1) + meanorigin(n,1,1)
     ENDDO
     nstatavg_pointsorigin = nstatavg_points + nstatavg_pointsorigin
  ENDIF

! ################
! # Writing data #
! ################

  afile='st                                '
  CALL CONCATI(afile, itime)
  CALL CONCAT(afile,'m')
  CALL CONCATI(afile, itimeorigin)

  OPEN(UNIT=i55, FILE=afile, &
       FORM='unformatted',STATUS='unknown')

  iop = 0
  CALL WRT_STHD ( i55, iop, istat_maj_ver, istat_min_ver, &
       itime, rtime, istattimeorgorigin, &
       rstattimeorgorigin, nstatavg, jmax, inb_mean_spatial, &
       nstatavg_pointsorigin, statavg )

  WRITE(i55) meanorigin

  CLOSE(i55)

  RETURN
END SUBROUTINE ADD_SUBS
