PROGRAM STATTRNS
  
#include "types.h"

  USE DNS_GLOBAL

  IMPLICIT NONE

  TREAL x(:)
  ALLOCATABLE x
  TREAL y(:)
  ALLOCATABLE y
  TREAL z(:)
  ALLOCATABLE z
  TREAL x_dst(:)
  ALLOCATABLE x_dst
  TREAL y_dst(:)
  ALLOCATABLE y_dst
  TREAL z_dst(:)
  ALLOCATABLE z_dst
  TREAL wrk1d(:,:)
  ALLOCATABLE wrk1d
  TREAL wrk2d(:,:)
  ALLOCATABLE wrk2d
  TREAL meanaux(:,:,:)
  ALLOCATABLE meanaux
  TREAL mean(:,:,:)
  ALLOCATABLE mean
  TREAL t_dat(:,:)
  ALLOCATABLE t_dat
  TREAL t_dataux(:,:)
  ALLOCATABLE t_dataux
  TREAL l_dat(:,:,:,:)
  ALLOCATABLE l_dat
  TREAL l_dataux(:,:,:,:)
  ALLOCATABLE l_dataux
  TREAL p_dat(:,:,:,:,:)
  ALLOCATABLE p_dat
  TREAL p_dataux(:,:,:,:,:)
  ALLOCATABLE p_dataux

  TINTEGER iitime, itimeorigin, nstat
  TINTEGER i0
  TINTEGER iop, itxc
  TINTEGER imax_dst, jmax_dst, kmax_dst, nrest_dst, nrest_loc
  TREAL scalex_dst, scaley_dst, scalez_dst
  CHARACTER*32 afile

  i0 = 0
  CALL DNS_INITIALIZE

  CALL DNS_READ_GLOBAL('dns.ini')

  ALLOCATE(x(imax))
  ALLOCATE(y(jmax))
  ALLOCATE(z(kmax))
  ALLOCATE(wrk1d(isize_wrk1d,inb_wrk1d))
  ALLOCATE(wrk2d(isize_wrk2d,inb_wrk2d))
  ALLOCATE(mean(nstatavg,jmax,inb_mean_spatial))
  ALLOCATE(t_dat(2,nspa_rest))
  ALLOCATE(l_dat(kmax_total,inb_vars,nstatlin,nspa_rest))
  ALLOCATE(p_dat(jmax,kmax_total,nstatplnvars,nstatpln,nspa_rest))

! #########################################
! # Get file names if not on command line #
! #########################################

  WRITE(*,*) 'Integral Iteration ?'
  READ(*,*) iitime

  WRITE(*,*) '################################'
  WRITE(*,*) '# DNS Parameter : dns.ini      #'
  afile='st                              '
  CALL CONCATI(afile, iitime)
  WRITE(*,*) '# Stat File ....: ', afile
  afile='ln                              ' 
  CALL CONCATI(afile, iitime)
  WRITE(*,*) '# Line File ....: ', afile
  afile='ip                              ' 
  CALL CONCATI(afile, iitime)
  WRITE(*,*) '# Plane File ...: ', afile
  WRITE(*,*) '################################'

  CALL IO_READ_GRID(gfile, imax,jmax,kmax, scalex,scaley,scalez, x,y,z)

  IF ( kmax .GT. 1 ) THEN
     area = scalex * scalez
  ELSE
     area = scalex
  ENDIF

! ###############
! # Global menu #
! ###############

  WRITE(*,*) ' '
  WRITE(*,*) 'Main Options'
  WRITE(*,*) '1 - Averages'
  WRITE(*,*) '2 - Line data'
  WRITE(*,*) '3 - Plane data'
  WRITE(*,*) '9 - End'
  READ(*,*) iop

! ############
! # Averages #
! ############

  IF (iop .EQ. 1) THEN

! Local menu

100  WRITE(*,*) ' '
     WRITE(*,*) 'Average trnasformation'
     WRITE(*,*) '1 - Substraction'
     WRITE(*,*) '2 - Addition'
     WRITE(*,*) '3 - Change grid'
     WRITE(*,*) '9 - End'
     READ(*,*) iop

! Reading

     afile='st                                '
     CALL CONCATI(afile, iitime)
     CALL DNS_READ_AVGIJ( afile, mean )

     ALLOCATE(t_dataux(1,1))
     ALLOCATE(l_dataux(1,1,1,1))
     ALLOCATE(p_dataux(1,1,1,1,1))

     IF ( iop .NE. 3 ) THEN
        ALLOCATE(x_dst(1))
        ALLOCATE(y_dst(1))
        ALLOCATE(z_dst(1))
        ALLOCATE(meanaux(nstatavg,jmax,inb_mean_spatial))
     ELSE
        WRITE(*,*) 'New imax ?'
        READ(*,*) imax_dst
        WRITE(*,*) 'New jmax ?'
        READ(*,*) jmax_dst
        WRITE(*,*) 'New kmax ?'
        READ(*,*) kmax_dst
        ALLOCATE(x_dst(imax_dst))
        ALLOCATE(y_dst(jmax_dst))
        ALLOCATE(z_dst(kmax_dst))
        ALLOCATE(meanaux(nstatavg,jmax_dst,inb_mean_spatial))
     ENDIF

     IF ( iop .EQ. 1 ) THEN
        WRITE(*,*) 'Integral Iteration to substract from ?'
        READ(*,*) itimeorigin
        CALL ADD_SUBS( iop, itimeorigin, mean, meanaux )
     ELSE IF ( iop .EQ. 2 ) THEN
        WRITE(*,*) 'Integral Iteration to add to ?'
        READ(*,*) itimeorigin
        CALL ADD_SUBS( iop, itimeorigin, mean, meanaux )
     ELSE IF ( iop .EQ. 3 ) THEN
        WRITE(*,*) 'Destination Grid File'
        READ(*,*)  afile
        CALL IO_READ_GRID(afile, imax_dst,jmax_dst,kmax_dst, &
             scalex_dst,scaley_dst,scalez_dst, x_dst,y_dst,z_dst)
        IF ( scaley_dst .NE. scaley ) THEN
           CALL IO_WRITE_ASCII('dns.error','Stattrns: y-scales do not match')
           CALL DNS_STOP(600)
        ENDIF
        CALL IO_WRITE_GRID('Grid.in-trn', imax,jmax_dst,kmax, scalex,scaley,scalez, x,y_dst,z)
        CALL CHGRES_AVG ( jmax, jmax_dst, nstatavg, nstat,&
             nstatavg_points, istat_maj_ver, istat_min_ver,&
             itime, scaley, rtime, &
             istattimeorg, rstattimeorg, statavg, &
             y, y_dst, mean, meanaux, wrk1d )
     ENDIF

! #############
! # Line data #
! #############

  ELSEIF (iop .EQ. 2) THEN

! local menu

200  WRITE(*,*) ' '
     WRITE(*,*) 'Line data transformation'
     WRITE(*,*) '1 - Extract time-series'
     WRITE(*,*) '2 - Gather files'
     WRITE(*,*) '3 - Change resolution'
     WRITE(*,*) '9 - End'
     READ(*,*) iop

! Reading 

     afile='ln                              ' 
     CALL CONCATI(afile, iitime)
     itxc = isize_wrk2d*inb_wrk2d
     nrest_loc = nspa_rest
     CALL DNS_READ_LINE( afile, iitime, rtime, nrest_loc,&
          nstatlin, statlin_i, statlin_j, inb_vars, kmax,&
          kmax_total, t_dat, l_dat, itxc, wrk2d )

     IF ( iop .NE. 3 ) THEN
        ALLOCATE(x_dst(1))
        ALLOCATE(y_dst(1))
        ALLOCATE(z_dst(1))
        ALLOCATE(meanaux(1,1,1))
        ALLOCATE(p_dataux(1,1,1,1,1))

        IF ( iop .EQ. 1 ) THEN
           ALLOCATE(t_dataux(1,1))
           ALLOCATE(l_dataux(1,1,1,1))
        ELSEIF ( iop .EQ. 2 ) THEN 
           WRITE(*,*) 'New nrest ?'
           READ(*,*) nrest_dst
           ALLOCATE(t_dataux(2,nrest_dst))
           ALLOCATE(l_dataux(kmax_total,inb_vars,nstatlin,nrest_dst))
        ENDIF

     ELSE
        WRITE(*,*) 'New imax ?'
        READ(*,*) imax_dst
        WRITE(*,*) 'New jmax ?'
        READ(*,*) jmax_dst
        WRITE(*,*) 'New kmax ?'
        READ(*,*) kmax_dst
        ALLOCATE(x_dst(imax_dst))
        ALLOCATE(y_dst(jmax_dst))
        ALLOCATE(z_dst(kmax_dst))
        ALLOCATE(meanaux(1,1,1))
        ALLOCATE(t_dataux(1,1))
        ALLOCATE(l_dataux(kmax_dst,inb_vars,nstatlin,nspa_rest))
     ENDIF

     IF ( iop .EQ. 1 ) THEN
        CALL TIMESERIES ( kmax_total, inb_vars, nstatlin, &
             nspa_rest, &
             iitime, statlin_i, statlin_j, t_dat, l_dat )
     ELSEIF ( iop .EQ. 2 ) THEN
        CALL LINE_GATHER ( nspa_rest, nrest_loc, nrest_dst, &
             kmax_total, &
             inb_vars, nstatlin, statlin_i, statlin_j, &
             t_dat, l_dat, t_dataux, l_dataux )
     ENDIF

! ##############
! # Plane data #
! ##############

  ELSEIF (iop .EQ. 3) THEN

! local menu

300  WRITE(*,*) ' '
     WRITE(*,*) 'Plane data transformation'
     WRITE(*,*) '9 - End'
     READ(*,*) iop

! Reading 

     afile='pl                              ' 
     CALL CONCATI(afile, iitime)
     itxc = isize_wrk2d*inb_wrk2d
     nrest_loc = nspa_rest
     CALL DNS_READ_PLANE(afile, iitime, rtime, nrest_loc,&
          nstatpln, statpln, jmax, nstatplnvars, kmax, kmax_total, itxc, t_dat, p_dat, wrk2d )

     ALLOCATE(x_dst(1))
     ALLOCATE(y_dst(1))
     ALLOCATE(z_dst(1))
     ALLOCATE(meanaux(1,1,1))
     ALLOCATE(t_dataux(1,1))
     ALLOCATE(l_dataux(1,1,1,1))
     ALLOCATE(p_dataux(jmax,kmax_total,nstatplnvars,nstatpln,nspa_rest))

  ENDIF

  CALL DNS_END(i0)

  STOP
END PROGRAM STATTRNS

